package fsmv;

import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

import fsmv.phi.Configuration;

public abstract class FSMv {

	String name;
	char type;
	List<Configuration> listOfValidConfiguration;
	
	public abstract void generateValidConfiguration();

	public boolean serialize(String fileName){
		try{
		FileWriter file=new FileWriter(fileName);
		file.write(this.toString());
		file.close();
		return true;
		}catch(IOException e)
		{
		//System.out.println(e);
		return false;
		}
	}

	public List<Configuration> getListOfValidConfiguration() 
	{
		if(listOfValidConfiguration==null)
			generateValidConfiguration();
		return listOfValidConfiguration;
	}

	public  char getType()
	{
		return this.type;
	}

	public String getName()
	{
		return name;
	}
        
        @Override
        public boolean equals(Object o)
        {
            if(!(o instanceof FSMv))
            return false;
        
            return this==o;
        }

	public abstract String toString();

	public abstract List<FSMvEvent> getEvents();

	public abstract List<FSMvVariable> getVariables();
	
	public abstract FSMvRho getRho();

	public abstract FSMvVariable getVariableFromName(String varName);

}