package fsmv;

import java.io.Serializable;

public class FSMvState implements Serializable{

    private static final long serialVersionUID = 4502033215068927936L;
	
    final private String state;
    final private boolean initial;
    
    FSMvState(String _state) {
        this(_state,false);
    }

    FSMvState(String _state, boolean _initial) {
        state = _state;
        initial = _initial;
    }
    
    public String toString(){
        String text;
        if(initial)
            text="-->"+state;
        else
            text=state;
        return text;
    }

    public String getState() {
        return state;
    }
    
    public boolean isInitial() {
        return initial;
    }
    
    public FSMvState clone() {
        return new FSMvState(this.state, this.initial);
    }

    public boolean equals(FSMvState s) {
        return (s.getState().equals(this.state)) && (this.initial == s.isInitial());
    }
}
