package fsmv;

import java.util.*;

public class FSMvVariable {
	
        private final String featureName;
        private final char type;
	private final String v_name;
	private final List<String> values;
	
	FSMvVariable(String _featureName, char _type, String _v_name, List<String> _value)
	{
                featureName=_featureName;
                type=_type;
		v_name=_v_name;
		values=_value;
	}
	public String toString()
	{
		String text;
		text=" <variable>\n   <v_name>"+v_name+"</v_name>\n";
		for(int i=0;i<values.size();i++)
			text+="     <value>"+values.get(i)+"</value>\n";
		text+=" </variable>\n";
		return text;
	}
	
	public String getV_name() 
	{
		return v_name;
	}
	
	public List<String> getValues() 
        {
		return values;
	}

        public boolean contains(String val) 
        {
                for(String value:this.values)
                {
                    if(val.equals(value))
                        return true;
                }
                return false;
        }
        
        public String getQualifiedName()
        {
            return this.featureName+"."+this.type+"."+this.v_name;
        }
        
        public List<String> getQualifiedValues()
        {
            List<String> result=new ArrayList<>();
            for(String value:this.values)
            {
                result.add(this.featureName+"."+this.type+"."+this.v_name+"."+value);
            }
            return result;
        }
}
