package fsmv;

import java.util.*;

import fsmv.parsor.Parsor;
import fsmv.phi.Configuration;
import fsmv.predicate.Predicate;



public final class SingleFSMv extends FSMv {
		
		private final List<FSMvState> states;
		private final List<FSMvEvent> events;
		private final List<FSMvVariable> variables;
		private final FSMvRho rho;
		private final List<FSMvTransition> transitions;
		private final List<FSMvVD> vds;
		
		public SingleFSMv(String file)
		{
			states=new ArrayList<>();
	        events=new ArrayList<>();
	        variables=new ArrayList<>();
	        transitions=new ArrayList<>();
	        vds=new ArrayList<>();
	        List<Predicate> P=new ArrayList<>();
	
	         Parsor p = new Parsor(file);
	
	         List<String> bruteData=p.parse();
	
	        int index=0;
	        if(!bruteData.get(index).equals("<?xml version='1.0'>") && !bruteData.get(index).equals("<?xml version='1.0'?>") )
	                throw new RuntimeException("The file "+file+" cannot be parsed."); 
	        index++;
	        if(!bruteData.get(index).equals("<FSMv>"))
	                throw new RuntimeException("The file "+file+" cannot be parsed."); 
	        index++;
	        while(!bruteData.get(index).equals("</FSMv>"))
	        {
	                //System.out.println("entering while loop with :"+bruteData.get(index));
	                String current= bruteData.get(index);
	                if(current.equals("<name>"))
	                {
	                        index++;
	                        this.name=bruteData.get(index);
	                        index++;
	                        index++;
	                }
	                else if(current.equals("<type>"))
	                {
	                        index++;
	                        char[] c=new char[1];
	                        bruteData.get(index).getChars(0, 1, c, 0);
	                        //System.out.println("type:"+c[0]);
	                        this.type=(""+c[0]).toUpperCase().toCharArray()[0];
	                        index++;index++;
	                }
	                else if(current.equals("<states>"))
	                {
	                        //System.out.println("entering states loop");
	                        index++;
	                        while(bruteData.get(index).startsWith("<s"))
	                        {
	                                index++;
	                                boolean initial=false;
	                                String statename= bruteData.get(index);
	                                if(bruteData.get(index-1).length()>3)
	                                        initial=true;
	                                FSMvState s=new FSMvState(statename,initial);
	                                states.add(s);
	                                index++;
	                                index++;
	                        }
	                        index++;
	                        //System.out.println(states);
	                }
	                else if(current.equals("<set_of_sets_of_final_states>"))
	                {
	                        System.out.println("The parsed file is an old version.\n Please remove the section <set_of_sets_of_final_states>");
	                        index++;
	                        while(!bruteData.get(index).equals("</set_of_sets_of_final_states>"))
	                        {
	                                index++;
	                        }
	                        index++;
	                }
	                else if(current.equals("<events>"))
	                {
	                        index++;
	                        while(bruteData.get(index).equals("<e>"))
	                        {
	                                index++;
	                                String eventname= bruteData.get(index);
	                                FSMvEvent e=new FSMvEvent(eventname);
	                                events.add(e);
	                                index++;
	                                index++;
	                        }
	                        index++;
	                //System.out.println(events);	
	                }else if(current.equals("<variables>"))
	                {
	                        index++;
	                        while(bruteData.get(index).equals("<variable>"))
	                         {
	                                index++;
	                                if(bruteData.get(index).equals("<v_name>"))
	                                        {	
	                                                index++;
	                                                String v_name=bruteData.get(index);
	                                                index++;index++;
	                                                List<String> value1= new ArrayList<>();
	                                                while(bruteData.get(index).equals("<value>"))
	                                                {
	                                                        index++;
	                                                        String value=bruteData.get(index);
	                                                        value1.add(value);
	                                                        index++;index++;
	                                                }
	                                                FSMvVariable v=new FSMvVariable(this.name, this.type, v_name, value1);
	                                                variables.add(v);
	                                        }
	                                index++;
	                         }
	                        index++;
	                        //System.out.println(variables);
	
	                }else if(current.equals("<rho>"))
	                {
	                        index++;
	                        while(bruteData.get(index).equals("<conjunct>"))
	                        {
	                                index++;
	                                String predicate=bruteData.get(index); 
	                                P.add(new Predicate(predicate));
	                                index++;index++;
	                        }
	                        //System.out.println(rho);
	                        index++;
	                }else if(current.equals("<vds>"))
	                {
	                        index++;
	                        while(bruteData.get(index).equals("<predicate>"))
	                        {
	                            index++;index++;
	                            String id=bruteData.get(index);
	                            index++;index++;index++;
	                            String pred=bruteData.get(index);
	                            Predicate P2 =new Predicate(pred);
	                            index++;
	                            index++;
	                            FSMvVD v=new FSMvVD(P2,id);
	                            vds.add(v);
	                            index++;
	                        }
	                        index++;
	                        //System.out.println(vds);
	                }else if(current.equals("<transitions>"))
	                {
	                        index++;
	                                while(bruteData.get(index).equals("<t>"))
	                                {
	                                        index++;index++;
	                                        String start=bruteData.get(index);
	                                        FSMvState Source=null;
	                                        for(int i=0;i<this.states.size();i++)
	                                                if(states.get(i).getState().equals(start))
	                                                {
	                                                        Source=states.get(i);
	                                                        break;
	                                                }
	                                        index++;index++;index++;
	                                        String end=bruteData.get(index);
	                                        FSMvState Dest=null;
	                                        for(int i=0;i<this.states.size();i++)
	                                                if(states.get(i).getState().equals(end))
	                                                {
	                                                        Dest=states.get(i);
	                                                        break;
	                                                }
	                                        index++;index++;index++;
	                                        String id=bruteData.get(index);
	                                        FSMvVD vd=null;
	                                        for(int i=0;i<this.vds.size();i++)
	                                                if(vds.get(i).getId().equals(id))
	                                                {
	                                                        vd=vds.get(i);
	                                                        break;
	                                                }
	                                        index++;index++;index++;
	                                        String event=bruteData.get(index);
	                                        FSMvEvent Event=null;
	                                        for(int i=0;i<this.events.size();i++)
	                                                if(events.get(i).getEvent().equals(event))
	                                                {
	                                                        Event=events.get(i);
	                                                        break;
	                                                }
	                                        index++;index++;
	                                        assert(Source!=null && Dest != null && vd != null);
	                                        FSMvTransition t=new FSMvTransition(Source,Dest,vd,Event);
	                                        transitions.add(t);
	                                        index++;
	
	                                }
	                        index++;
	                        //System.out.println(transitions);
	                }
	                else
	                {
	                        System.out.println("Token error while creating the FSMv, Current token="+bruteData.get(index));
	                        throw new RuntimeException("The file "+file+" cannot be parsed."); 
	                }//System.out.println("ready to leave while loop");
	        }
	        assert(!P.isEmpty());
	        rho=new FSMvRho(P);
	        //System.out.println(""+bruteData);
	        
	        //Normalize the name of the variable in the Rho and vds
	        this.normalizeRhoAndVDs();
	       
	        this.generateValidConfiguration();
		}

		private void normalizeRhoAndVDs()
		{
			String added=this.name+"."+this.type+".";
			String replacement="$1"+added+"$2$3";
			
			//Set up the Regex: Every variable that is not preceded by a "." and followed by an "="
            StringBuilder pattern=new StringBuilder("([^\\.])(");
            String delim="";
            for(FSMvVariable var:this.variables)
            {
            	pattern.append(delim);
            	pattern.append(var.getV_name());
            	delim="|";
            }
            pattern.append(")\\s*(=)\\s*");
            
            //System.out.println(pattern);
            
            //Convert Rho
            for(Predicate pred:this.rho.getConjuncts())
            {
            	pred.replaceAll(pattern.toString(), replacement);
            	//System.out.println(pred);
            }
            
            //Convert the VDs
            for(FSMvVD vd:this.vds)
            {
            	vd.getVd().replaceAll(pattern.toString(), replacement);
            	//System.out.println(vd.getVd());
            }
		}
		
		/* (non-Javadoc)
		 * @see fsmv.FSMv#generateValidConfiguration()
		 */
		@Override
		public void generateValidConfiguration()
		{
			listOfValidConfiguration=new ArrayList<>();
			int possible_configuration=1, current_fraction=1;
			
			for(int i=0;i<this.variables.size();i++)
				possible_configuration*=this.variables.get(i).getQualifiedValues().size();
			//System.out.println(possible_configuration);
			List<Configuration> all_configuration=new ArrayList<>(possible_configuration);
			
			for(int j=0;j<possible_configuration;j++)
				all_configuration.add(new Configuration());
			
			for(int i=0;i<this.variables.size();i++)
			{
				current_fraction*=this.variables.get(i).getQualifiedValues().size();
				for(int j=0;j<possible_configuration;j++)
				{
					int x=((j*current_fraction)/possible_configuration)%this.variables.get(i).getQualifiedValues().size();
					all_configuration.get(j).getListOfVariable_value().put(variables.get(i).getQualifiedName(), variables.get(i).getValues().get(x));
				}
			}
			//System.out.println("All configurations:"+all_configuration);
			
			for(int i=0;i<all_configuration.size();i++)
			{
				if(rho.isSatisfiedBy(all_configuration.get(i)))	
					this.listOfValidConfiguration.add(all_configuration.get(i));
			}
			//System.out.println("\n\n"+listOfValidConfiguration);
		}
		
		/* (non-Javadoc)
		 * @see fsmv.FSMv#toString()
		 */
		@Override
		public String toString(){
			String text;
			text="<?xml version='1.0'>\n<FSMv>\n<type>"+type+"</type>\n<states>\n";
			for(int i=0;i<states.size();i++)
				text+=states.get(i).toString();
			text+="</states>\n";
			text+="  <events>\n";
			for(int i=0;i<events.size();i++)
				text+=events.get(i).toString();
			text+="</events>\n<variables>\n";
			for(int i=0;i<variables.size();i++)
				text+=variables.get(i).toString();
			text+="</variables>\n";
			text+=rho.toString();
			text+="<vds>\n";
			for(int i=0;i<vds.size();i++)
				text+=vds.get(i).toString();
			text+="</vds>\n<transitions>\n";
			for(int i=0;i<transitions.size();i++)
				text+=transitions.get(i).toString();
			text+="</transitions>\n</FSMv>\n";
			return text;
		}

		public List<FSMvState> getStates() {
			return states;
		}

		/* (non-Javadoc)
		 * @see fsmv.FSMv#getEvents()
		 */
		//@Override
		public List<FSMvEvent> getEvents() {
			return events;
		}

		/* (non-Javadoc)
		 * @see fsmv.FSMv#getVariables()
		 */
		@Override
		public List<FSMvVariable> getVariables() {
			return variables;
		}

		/* (non-Javadoc)
		 * @see fsmv.FSMv#getRho()
		 */
		@Override
		public FSMvRho getRho() {
			return rho;
		}

		public List<FSMvTransition> getTransitions() {
			return transitions;
		}

		public List<FSMvVD> getVds() {
			return vds;
		}

		/* (non-Javadoc)
		 * @see fsmv.FSMv#getType()
		 */
		@Override
		public char getType() {
			return type;
		}
		
		/* (non-Javadoc)
		 * @see fsmv.FSMv#getVariableFromName(java.lang.String)
		 */
		@Override
		public FSMvVariable getVariableFromName(String varName) 
		{
                    String name=varName;
                    if(name.startsWith(this.name+"."+this.type+"."))
                    {
                        name=name.split("\\.")[2];
                    }
                    
                    for(FSMvVariable var:this.variables)
                    {
                        if(var.getV_name().equals(varName))
                            return var;
                    }
                    return null;
		}

		/*
		public static FSMv compose(FSMv fsmv1, FSMv fsmv2)
		{
			List<Predicate> predList=new ArrayList<>();
			predList.add(new Predicate("1"));
			return FSMv.compose(fsmv1, fsmv2, new FSMvRho(predList));
		}
		public static FSMv compose(FSMv fsmv1, FSMv fsmv2, FSMvRho compositionPredicate)
		{
			FSMv composed=new FSMv();
			
			//The type
			if(fsmv1.type!=fsmv2.type)
				return null;
			composed.type=fsmv1.type;
			
			//The name
			composed.name=fsmv1.name+"_"+fsmv2.name;
			
			//The event list
			composed.events=new ArrayList<>();
			composed.events.addAll(fsmv1.events);
			Set<FSMvEvent> H=new HashSet<>();
			for(FSMvEvent event: fsmv2.events)
			{
				boolean isContained=false;
				for(FSMvEvent event2:fsmv1.events)
				{
					if(event.event.equals(event2.event))
					{
						isContained=true;
						break;
					}
				}
				
				if(isContained)
				{
					H.add(event);
				}
				else
				{
					composed.events.add(event);
				}
			}
			
			
			//The variable list (independent variables)
			composed.variables=new ArrayList<>();
			composed.variables.addAll(fsmv1.variables);
			composed.variables.addAll(fsmv2.variables);
			
			//The rho
			List<Predicate> P=new ArrayList<>();
			P.addAll(fsmv1.rho.getConjuncts());
			P.addAll(fsmv2.rho.getConjuncts());
			P.addAll(compositionPredicate.getConjuncts());
			composed.rho=new FSMvRho(P);
			
			
			//Generate all the states but add them in the list only when connected
			Map<String,FSMvState> mapState=new HashMap<>();
			String stateName;
			FSMvState initialState=null, initState1=null, initState2=null;
			
			boolean initial;
			for(FSMvState state1: fsmv1.states)
			{
				for(FSMvState state2: fsmv2.states)
				{
					stateName=state1.state+"_"+state2.state;
					initial=state1.isInitial() && state2.isInitial();
					FSMvState currentState=new FSMvState(stateName, initial);
					mapState.put(stateName, currentState);
					
					if(initial)
					{
						initialState=currentState;
						initState1=state1;
						initState2=state2;
					}
				}
			}
			composed.states=new ArrayList<>();
			
			//Generate all the composition of vds but add them only when used
			Map<String,FSMvVD> mapVDs=new HashMap<>();
			String pred, id;
			FSMvVD compVD;
			
			for(FSMvVD vd1: fsmv1.vds)
			{
				pred=vd1.getVd().getEqu();
				id="_"+vd1.getId();
				compVD=new FSMvVD(new Predicate(pred),id);
				mapVDs.put(id, compVD);
			}

			
			for(FSMvVD vd2: fsmv2.vds)
			{
				pred=vd2.getVd().getEqu();
				id=vd2.getId()+"_";
				compVD=new FSMvVD(new Predicate(pred),id);
				mapVDs.put(id, compVD);
			}
			
			for(FSMvVD vd1: fsmv1.vds)
			{
				for(FSMvVD vd2: fsmv2.vds)
				{
					//TODO call Yices to prune the unsatisfiable branches
					pred="and("+vd1.getVd().getEqu()+","+vd2.getVd().getEqu()+")";
					id=vd1.getId()+"_"+vd2.getId();
					compVD=new FSMvVD(new Predicate(pred),id);
					mapVDs.put(id, compVD);
				}
			}
			composed.vds=new ArrayList<>();
			
			composed.transitions=new ArrayList<>();
			
			FSMv.explore(initialState, initState1, initState2, mapState, mapVDs, H, composed, fsmv1, fsmv2);
			
			return composed;
		}
		
		private static void explore(FSMvState state, FSMvState state1, FSMvState state2, Map<String,FSMvState> mapState, Map<String,FSMvVD> mapVDs, Set<FSMvEvent> H, FSMv composed, FSMv fsmv1, FSMv fsmv2)
		{
			if(composed.getStates().contains(state))
				return;
			
			composed.getStates().add(state);
			
			for(FSMvTransition t1: fsmv1.getTransitions())
			{
				if(!t1.getSource().equals(state1))
					continue;
				if(H.contains(t1.getEvent()))
					//will do synchronized event later
					continue;
				
				FSMvState dest=mapState.get(t1.getDestination().state+"_"+state2.state);
				FSMvTransition composedTransition=new FSMvTransition(state, dest, mapVDs.get("_"+t1.getVd().id), t1.getEvent());
				composed.transitions.add(composedTransition);
				FSMv.explore(dest, t1.getDestination(), state2, mapState, mapVDs, H, composed, fsmv1, fsmv2);
			}
			
			for(FSMvTransition t2: fsmv2.getTransitions())
			{
				if(!t2.getSource().equals(state2))
					continue;
				if(H.contains(t2.getEvent()))
					//will do synchronized event later
					continue;
				
				FSMvState dest=mapState.get(state1.state+"_"+t2.getDestination().state);
				FSMvTransition composedTransition=new FSMvTransition(state, dest, mapVDs.get(t2.getVd().id+"_"), t2.getEvent());
				composed.transitions.add(composedTransition);
				FSMv.explore(dest, state1, t2.getDestination(), mapState, mapVDs, H, composed, fsmv1, fsmv2);
			}
			
			//Synchronized event
			for(FSMvTransition t1: fsmv1.getTransitions())
			{
				if(!t1.getSource().equals(state1))
					continue;
				if(H.contains(t1.getEvent()))
				{
					//t1 holds a synchronized event
					
					for(FSMvTransition t2: fsmv2.getTransitions())
					{
						if(!t2.getSource().equals(state2))
							continue;
						if(H.contains(t2.getEvent()))
						{
							//t2 also hold a synchronized event
							
							//Let's check if they are the same
							if(!t1.getEvent().equals(t2.getEvent()))
								continue;
							
							//They are
							FSMvState dest=mapState.get(t1.getDestination().state+"_"+t2.getDestination().state);
							FSMvTransition composedTransition=new FSMvTransition(state, dest, mapVDs.get(t1.getVd().id+"_"+t2.getVd().id), t1.getEvent());
							composed.transitions.add(composedTransition);
							FSMv.explore(dest, t1.getDestination(), t2.getDestination(), mapState, mapVDs, H, composed, fsmv1, fsmv2);
						}
					}
				}
			}
			
		}*/
}
