package fsmv.phi;

import java.util.*;

public class Configuration {

	Map<String,String> listOfVariable_value;
	
	public Configuration()
	{
		this(new HashMap<String, String>());
	}
	
	public Configuration(Map<String, String> _listOfConfiguration)
	{
		listOfVariable_value= _listOfConfiguration;
	}
	
	public String toString()
	{
		String text="";
		//text="<Configuration>\n";
		List<String> variables=new ArrayList<>(listOfVariable_value.keySet());
		for(int i=0;i<variables.size();i++)
                {
                    String var=variables.get(i);
                    
                    var=var.replaceAll("[^\\.]+\\.(D|R)\\.([^\\.]+)", "$2");
                    
                    
                    String val=listOfVariable_value.get(variables.get(i));
                    
                    text+=var+"="+val+";";
                }
		//text+="</Configuration>\n";
		return text;
	}
	
	public boolean equals(Configuration c)
	{
		List<String> c_vars=new ArrayList<>(c.listOfVariable_value.keySet());
		List<String> vars=new ArrayList<>(this.listOfVariable_value.keySet());
		for(int i=0;i<c_vars.size();i++)
			if(!c.listOfVariable_value.get(c_vars.get(i)).equals(this.listOfVariable_value.get(c_vars.get(i))))
				return false;
		for(int i=0;i<vars.size();i++)
			if(!this.listOfVariable_value.get(vars.get(i)).equals(c.listOfVariable_value.get(vars.get(i))))
				return false;
		return true;
	}
	
	public String get(String key)
	{
		return listOfVariable_value.get(key);
	}
	
	public Map<String, String> getListOfVariable_value() 
	{
		return listOfVariable_value;
	}
	
	public void setListOfVariable_value(HashMap<String, String> listOfVariable_value) 
	{
		this.listOfVariable_value = listOfVariable_value;
	}
	
    public String toPredicateString()
    {
        StringBuilder text=new StringBuilder("");
        String delim="";
        int i=0;
        for(Map.Entry<String,String> entry: listOfVariable_value.entrySet())
        {
            text.append(delim);

            if(i<listOfVariable_value.size()-1)
                text.append("and(");

            text.append(entry.getKey())
                .append("=")
                .append(entry.getValue());

            delim=",";
            i++;
        }
        for(i=1; i<listOfVariable_value.size(); i++)
        text.append(")");
    
        return text.toString();
    }
    
    public String toPromelaString()
    {
        String predicate= this.toPredicateString();
        
        predicate=predicate.substring(3, predicate.length()-this.listOfVariable_value.size()+2);
        
        predicate=predicate.replaceAll(",and\\(", " && ");
        
        predicate=predicate.replaceAll(",", " && ");
        
        return predicate;
    }
}
