package fsmv.phi;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import fsmv.FSMv;

public class Phi {
    
    FSMv requirement, design;

    List<PhiCouple> listOfCorrespondanceMapping;
    
    Set<Configuration> listOfIllegalConfigurations;
    
    
    public Phi(FSMv des, FSMv req) 
    {
        this(des, req, new ArrayList<PhiCouple>());
    }

    public Phi(FSMv des, FSMv req, List<PhiCouple> _listOfCorrespondanceMapping) 
    {
    	this.design=des;
    	this.requirement=req;
        listOfCorrespondanceMapping = _listOfCorrespondanceMapping;
    }

    public FSMv getDesign(){return design;}
    
    public FSMv getRequirement(){return requirement;}
    
    public Set<Configuration> getListOfIllegalConfigurations() {
        return listOfIllegalConfigurations;
    }

    public void setListOfIllegalConfigurations(Set<Configuration> listOfIllegalConfigurations) {
        this.listOfIllegalConfigurations = listOfIllegalConfigurations;
    }

    public List<PhiCouple> getListOfCorrespondanceMapping() {
        return listOfCorrespondanceMapping;
    }

    public void setListOfCorrespondanceMapping(List<PhiCouple> listOfCorrespondanceMapping) {
        this.listOfCorrespondanceMapping = listOfCorrespondanceMapping;
    }

    public String toString() {
        String text = "<Phi>\n";
        for (PhiCouple p : listOfCorrespondanceMapping) {
            text += p.toString();
        }
        text += "</Phi>\n";
        return text;
    }

    public List<Configuration> getCorrespondancesTo(Configuration desConf) {
        List<Configuration> result = new ArrayList<>();
        for (PhiCouple c : listOfCorrespondanceMapping) {
            if (c.getDesign().equals(desConf)) {
                result.add(c.getRequirement());
            }
        }
        return result;
    }
    
    @Override
    public boolean equals(Object o)
    {
        if(!(o instanceof Phi))
            return false;
        
        return o==this;
        
    }
     
}
