package fsmv.predicate;

public class Node {
	
	String content;
	Node father;
	Node leftSon;
	Node rightSon;
	
	public Node(){}
		
	public Node(String c, Node f)
	{
		this(c, f, null, null);
	}
	
	public Node(String c, Node f, Node l, Node r){
		content=c;
		father=f;
		leftSon=l;
		rightSon=r;
	}

	public String getContent() {
		return content;
	}

	public void setContent(String content) {
		this.content = content;
	}

	public Node getFather() {
		return father;
	}

	public void setFather(Node father) {
		this.father = father;
	}

	public Node getLeftSon() {
		return leftSon;
	}

	public void setLeftSon(Node leftSon) {
		this.leftSon = leftSon;
	}

	public Node getRightSon() {
		return rightSon;
	}

	public void setRightSon(Node rightSon) {
		this.rightSon = rightSon;
	}

	public static Node buildTree(String predicate)
	{

		Node seeker;
		
                Node tree = new Node("", null);
                
		byte[] pred=predicate.getBytes();
		
		seeker=tree;
		tree.setLeftSon(new Node("",tree));
		//System.out.println(""+predicate);
		for(int i=0;i<predicate.length();i++){
			
			
			
			if(pred[i]=='i'&&pred[i+1]=='f'&&pred[i+2]=='f'&&pred[i+3]=='(')
			{
				if(seeker.getLeftSon()==null)
				{
					seeker.setLeftSon(new Node("iff",seeker));
					seeker=seeker.getLeftSon();
				}else{
					seeker.setRightSon(new Node("iff",seeker));
					seeker=seeker.getRightSon();
				}
				i+=3;
				//continue;
			}
			else if(pred[i]=='i'&&pred[i+1]=='m'&&pred[i+2]=='p'&&pred[i+3]=='l'&&pred[i+4]=='i'&&pred[i+5]=='e'&&pred[i+6]=='s'&&pred[i+7]=='(')
			{
				if(seeker.getLeftSon()==null)
				{
					seeker.setLeftSon(new Node("implies",seeker));
					seeker=seeker.getLeftSon();
				}else{
					seeker.setRightSon(new Node("implies",seeker));
					seeker=seeker.getRightSon();
				}
				i+=7;
				//continue;
			}
			else if(pred[i]=='a'&&pred[i+1]=='n'&&pred[i+2]=='d'&&pred[i+3]=='(')
			{
				if(seeker.getLeftSon()==null)
				{
					seeker.setLeftSon(new Node("and",seeker));
					seeker=seeker.getLeftSon();
				}else{
					seeker.setRightSon(new Node("and",seeker));
					seeker=seeker.getRightSon();
				}
				i+=3;
				//continue;
			}
			else if(pred[i]=='o'&&pred[i+1]=='r'&&pred[i+2]=='(')
			{
				if(seeker.getLeftSon()==null)
				{
					seeker.setLeftSon(new Node("or",seeker));
					seeker=seeker.getLeftSon();
				}else{
					seeker.setRightSon(new Node("or",seeker));
					seeker=seeker.getRightSon();
				}
				i+=2;
				//continue;
			}
			else if(pred[i]=='n'&&pred[i+1]=='o'&&pred[i+2]=='t'&&pred[i+3]=='(')
			{
				if(seeker.getLeftSon()==null)
				{
					seeker.setLeftSon(new Node("not",seeker));
					seeker=seeker.getLeftSon();
				}else{
					seeker.setRightSon(new Node("not",seeker));
					seeker=seeker.getRightSon();
				}
				seeker.setLeftSon(new Node("",seeker));
				i+=3;
				//continue;
			}
			else if(pred[i]=='('){
				int j=i;
				while(pred[j]!=','&&pred[j]!=')'){
					j++;
				}
				if(seeker.getLeftSon()==null){
					seeker.setLeftSon(new Node(predicate.substring(i+1, j),seeker));
					i=j;
				}else {
					seeker.setRightSon(new Node(predicate.substring(i+1, j),seeker));
					seeker=seeker.getFather();
					i=j;
				}
			}else if(pred[i]!=')'&&pred[i]!=','){
				int j=i;
				while(pred[j]!=','&&pred[j]!=')'){
					j++;
				}
				if(pred[j]==','){
					seeker.setLeftSon(new Node(predicate.substring(i, j),seeker));
					i=j;
				}else {
					seeker.setRightSon(new Node(predicate.substring(i, j),seeker));
					seeker=seeker.getFather();
					i=j;
				}
			}else if(pred[i]==')'){
				seeker=seeker.getFather();
			}else if(pred[i]==','){
				if(seeker.getRightSon()!=null&&seeker!=tree){
					seeker=seeker.getFather();
				}
					
			}
			
		}
                return tree;
	}
	
	public String toString(){
		String text=this.content;
		if(this.content.equals("not"))
			text+="(";
		if(this.leftSon!=null&&!"".equals(this.leftSon.getContent())) 
                    text+="("+this.leftSon.toString()+",";
		if(this.rightSon!=null) 
                    text+=this.rightSon.toString();
		if(this.leftSon!=null&&!"".equals(this.leftSon.getContent())) 
                    text+=")";
		if("not".equals(this.content))
			text+=")";
		return text;
	}

	public String toYicesString()
	{
            String text="";

            if(this.content.contains("="))
            {
                    String[] pieces=content.split("=");
                    text+="(= "+pieces[0]+" "+pieces[1]+")";
                    return text;
            }
            switch (this.content) {
                case "not":
                    text+="(not ";
                    break;
                case "and":
                    text+="(and ";
                    break;
                case "or":
                    text+="(or ";
                    break;
                case "implies":
                    text+="(=> ";
                    break;
                case "iff":
                    text+="(= ";
                    break;
            }
            if(this.leftSon!=null&&!"".equals(this.leftSon.getContent())) text+=""+this.leftSon.toYicesString()+" ";
            if(this.rightSon!=null) text+=this.rightSon.toYicesString();
            if(this.leftSon!=null&&!"".equals(this.leftSon.getContent())) text+="";

            if("!".equals(this.content)||"and".equals(this.content)||"or".equals(this.content)||"implies".equals(this.content)||"iff".equals(this.content))
                    text+=")";
            return text;
	}
	
	public String toPromelaString(){
		String text="";
		if(this.leftSon!=null&&!this.leftSon.getContent().equals("")) 
                {
                    text+="(";
                    if(this.content.equals("implies") )
                        text+="!";
                    if(this.content.equals("iff"))
                        text+="(!";
                    
                    text+=this.leftSon.toPromelaString()+"";
                }
		
		if(this.content.equals("and"))
			text+=" && ";
		else if(this.content.equals("or")||this.content.equals("implies")|| this.content.equals("iff"))
			text+=" || ";
		else if(this.content.equals("not"))
			text+="!(";
		else 
		{
			this.content=this.content.replace("=", "==").replace(".", "_");
			if(this.content.contains("=="))
			{
				String[] elems=this.content.split("==");
				text+=elems[0]+"=="+elems[0]+"_"+elems[1];
			}
			else
				text+=this.content;
		}
                
		
		if(this.rightSon!=null&&!this.rightSon.getContent().equals("")) 
                    text+=""+this.rightSon.toPromelaString()+"";
		
		if(this.leftSon!=null&&!this.leftSon.getContent().equals("")) 
                    text+=")";
		if(this.content.equals("not"))
			text+=")";
                
        if(this.content.equals("iff"))
        {
            text+=" && (!";
            text+=""+this.rightSon.toPromelaString()+"";
            text+=" || ";
            text+=""+this.leftSon.toPromelaString()+"))";
        }
		return text;
	}
}
