package fsmv.predicate;

import java.util.ArrayList;
import java.util.List;

import fsmv.phi.Configuration;

public class Predicate {

    String equ;

    public Predicate(String _equ) {
        equ = _equ;
    }

    public String toString() {
        return getEqu();
    }
    
    public String getEqu() {
        return equ;
    }
    
    public boolean isSatisfiedBy(Configuration config)
	{
		String result=this.getEqu();
		
		if(result.equals("(true)")||result.equals("true"))
                    return true;
		
		if(result.equals("(false)")||result.equals("false"))
                    return false;
		
		List<String> var_name=new ArrayList<>(config.getListOfVariable_value().keySet());
		
		//Resolve the value of variable
		for(int i=0;i< var_name.size();i++)
		{
			/*System.out.println(result+"   "+var_name.get(i)+"="+config.get(var_name.get(i))
			+" replace:"+result.contains(var_name.get(i)+"="+config.get(var_name.get(i))+")")
		+" replace:"+result.contains(var_name.get(i)+"="+config.get(var_name.get(i))+")"));*/
			
			result=result.replace(var_name.get(i)+"="+config.get(var_name.get(i))+")","1)");
			result=result.replace(var_name.get(i)+"="+config.get(var_name.get(i))+",","1,");
			if(result.equals(var_name.get(i)+"="+config.get(var_name.get(i))))
				result="1";
			result=result.replaceAll(var_name.get(i)+"=[^,)]*", "0");//a-zA-Z0-9'.!?:-_
			if(result.contains(var_name.get(i)+"="))
				i--;
		}
		//System.out.println("end of value resolution"+result);
		
		// System.out.println("test: result="+result);
		//Resolve the logic
		String memory=result;
		while((!result.equals("1"))&(!result.equals("0")))
		{
			result=result.replaceAll("not\\(\\s*0\\s*\\)","1");
			result=result.replaceAll("not\\(\\s*1\\s*\\)","0");
			result=result.replaceAll("\\(\\s*0\\s*\\)","0");
			result=result.replaceAll("\\(\\s*1\\s*\\)","1");
			result=result.replaceAll("or\\(\\s*0\\s*,\\s*0\\s*\\)","0");
			result=result.replaceAll("or\\(\\s*1\\s*,\\s*0\\s*\\)","1");
			result=result.replaceAll("or\\(\\s*0\\s*,\\s*1\\s*\\)","1");
			result=result.replaceAll("or\\(\\s*1\\s*,\\s*1\\s*\\)","1");
			//result=result.replace("and(0)","0");
			//result=result.replace("and(1)","1");
			result=result.replaceAll("and\\(\\s*0\\s*,\\s*0\\s*\\)","0");
			result=result.replaceAll("and\\(\\s*1\\s*,\\s*0\\s*\\)","0");
			result=result.replaceAll("and\\(\\s*0\\s*,\\s*1\\s*\\)","0");
			result=result.replaceAll("and\\(\\s*1\\s*,\\s*1\\s*\\)","1");
			result=result.replaceAll("implies\\(\\s*0\\s*,\\s*0\\s*\\)","1");
			result=result.replaceAll("implies\\(\\s*1\\s*,\\s*0\\s*\\)","0");
			result=result.replaceAll("implies\\(\\s*0\\s*,\\s*1\\s*\\)","1");
			result=result.replaceAll("implies\\(\\s*1\\s*,\\s*1\\s*\\)","1");
			result=result.replaceAll("iff\\(\\s*0\\s*,\\s*0\\s*\\)","1");
			result=result.replaceAll("iff\\(\\s*1\\s*,\\s*0\\s*\\)","0");
			result=result.replaceAll("iff\\(\\s*0\\s*,\\s*1\\s*\\)","0");
			result=result.replaceAll("iff\\(\\s*1\\s*,\\s*1\\s*\\)","1");
			//System.out.println("During logic resolution >"+result+"<");
			
			if(memory.equals(result))
			{
				try{
				throw new syntaxErrorInPredicateException("Syntax error in a predicate. Current status is: "+result);
				}catch(syntaxErrorInPredicateException e)
				{
					e.printStackTrace();
					System.exit(-1);
				}
			}
			else memory=result;
		}
		//System.out.println("End of logic resolution"+result);
		if(result.equals("1"))
			return true;
		else return false;
	}

	public void replaceAll(String regex, String replacement) 
	{
		this.equ=this.equ.replaceAll(regex, replacement);
	}
}
