package fsmvVerifier.generator;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import fsmv.FSMvRho;
import fsmv.constants.IFSMVConstants;
import fsmv.predicate.Predicate;

public class FSMvRhoGenerator 
{
	String selectedDirPath;
	
	public FSMvRhoGenerator(String selectedDirPath)
	{
		this.selectedDirPath=selectedDirPath;
	}
	
	public FSMvRho createCompositionalConstraints(boolean design)
    {
        File tvlFile=design?new File(selectedDirPath + "/FSMd/"+IFSMVConstants.FSMD_CONSTRAINTS_FILE_TVL)
                            :new File(selectedDirPath + "/FSMr/"+IFSMVConstants.FSMR_CONSTRAINTS_FILE_TVL);
        
        return tvlFile.exists()?createCompositionalConstraintsFromTVL(design)
                               :createCompisitionalConstraintsFromFSMv(design);
    }
    
    private FSMvRho createCompisitionalConstraintsFromFSMv(boolean design)
    {
        String fileName;
        List<Predicate> predicates=new ArrayList<>();
        
        if(design)
            fileName=selectedDirPath + "/FSMd/"+IFSMVConstants.FSMD_CONSTRAINTS_FILE;
        else
            fileName=selectedDirPath + "/FSMr/"+IFSMVConstants.FSMR_CONSTRAINTS_FILE;
        
        try {
        	
        	
            BufferedReader reader = null;
            reader = new BufferedReader(new FileReader(fileName));
            String line;

            while ((line = reader.readLine()) != null && !"".equals(line.trim())) 
            {
                if (line.trim().length() == 0) 
                {
                    continue;
                }
                if (line.charAt(0) == '#') 
                {
                    continue;
                }
                predicates.add(new Predicate(line));
            }
            reader.close();
        }
        catch (IOException ex) {
        	ex.printStackTrace();
        }
        
        FSMvRho rho=new FSMvRho(predicates);
        
        //System.out.println(fileName+":\n"+rho);
        
         return rho;
    }
    
    private FSMvRho createCompositionalConstraintsFromTVL(boolean design)
    {
             File tvlFile=design?new File(selectedDirPath + "/FSMd/"+IFSMVConstants.FSMD_CONSTRAINTS_FILE_TVL)
                            :new File(selectedDirPath + "/FSMr/"+IFSMVConstants.FSMR_CONSTRAINTS_FILE_TVL);
            
            return new FSMvRho(tvlFile, design);
    }
}
