/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fsmvVerifier.generator.promela;

import fsmv.FSMvEvent;
import fsmv.SingleFSMv;
import fsmv.predicate.Node;
import fsmv.predicate.Predicate;

/**
 *
 * @author jvmillo
 */
public class ModelGenerator extends AbstractGenerator
{
    private int order;
    private final int nbProcesses;

    public ModelGenerator(int order, int nbProcesses)
    {
        this.order=order;
        this.nbProcesses=nbProcesses;
    }
    
    @Override
    protected void processASingleFSMv(StringBuilder text, SingleFSMv fsmv) 
    {
        String name=fsmv.getName()+"_"+fsmv.getType();
        String prefix=name+"_";
            
        text.append("proctype ");
        text.append(name);
        text.append("() {\n");
        //Set the initial state
        text.append("mtype currentEvent; \n  ");
        text.append(prefix);
        text.append("state=");
        for (int i = 0; i < fsmv.getStates().size(); i++) {
            if (fsmv.getStates().get(i).isInitial()) 
            {
                text.append(prefix).append(fsmv.getStates().get(i).getState()).append(";\n");
                break;
            }
        }
        //Build the automata as a switch cases structure
        text.append("do \n ::flag==");
        text.append(this.order);
        this.order=(this.order+1)%this.nbProcesses;
        text.append("-> ");
        text.append(prefix);
        text.append("evts");
        text.append("?currentEvent; \n");
        text.append("if \n");
        text.append(":: (");
        
        String delim="";
        for(FSMvEvent event: fsmv.getEvents())
        {
            text.append(delim);
            text.append("currentEvent==evt_");
            text.append(event.getEvent());
            delim=" || ";
        }
        
        text.append(")->\n ");
        text.append("if \n");
        for (int i = 0; i < fsmv.getStates().size(); i++) {
            text.append("::");
            text.append(prefix);
            text.append("state== ");
            text.append(prefix);
            text.append(fsmv.getStates().get(i).getState()).append("-> if \n");
            for (int j = 0; j < fsmv.getTransitions().size(); j++) {
                if (fsmv.getTransitions().get(j).getSource().getState().equals(fsmv.getStates().get(i).getState())) {
                    text.append("		::").append(convertVDPredicateInPromela(fsmv.getTransitions().get(j).getVd().getVd()))
                        .append(" && ")
                        .append(" currentEvent== evt_")
                        .append(fsmv.getTransitions().get(j).getEvent().getEvent())
                        .append("-> ")
                        .append(prefix)
                        .append("state=")
                        .append(prefix)
                        .append(fsmv.getTransitions().get(j).getDestination().getState())
                        .append("; \n");
                }
            }
            text.append("		::else -> ");
        text.append(prefix);
        text.append("state= ");
        text.append(prefix);
        text.append("error;\n 		fi;\n");
        }
        text.append("::else -> ");
        text.append(prefix);
        text.append("state = ");
        text.append(prefix);
        text.append("error; \n fi;\n");
        text.append(" ::else ;");
        text.append(" fi;");
        text.append("flag=")
                .append(this.order)
                .append("; \n od; \n }; \n\n\n");
    }
    
    
    

    private String convertVDPredicateInPromela(Predicate vd) 
    {

        String predicate = vd.getEqu();
        
        if(predicate.equals("(true)")||predicate.equals("true")||predicate.equals("(false)")||predicate.equals("false"))
        	return predicate;
        
        Node tree = Node.buildTree(predicate);

        return tree.toPromelaString();
    }
    
    public int getOrder()
    {
        return order;
    }
}
