/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author mint
 */
import java.awt.BorderLayout;
import java.awt.Container;
import java.io.File;
import java.util.Collections;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;


@SuppressWarnings("serial")
class DriveTree extends JPanel
{

    public DriveTree(File dir) 
    {
        setLayout(new BorderLayout());
        JTree tree = new JTree(addNodes(null, dir));
        add(tree);
    }

    DefaultMutableTreeNode addNodes(DefaultMutableTreeNode curTop, File dir)
    {
        String curPath = dir.getPath();
        DefaultMutableTreeNode curDir = new DefaultMutableTreeNode(curPath);
        if (curTop != null)
        {
          curTop.add(curDir);
        }
        Vector<String> ol = new Vector<>();
        String[] tmp = dir.list();
        for (int i = 0; i < tmp.length; i++)
        	ol.addElement(tmp[i]);
        Collections.sort(ol, String.CASE_INSENSITIVE_ORDER);
        File f;
        Vector<String> files = new Vector<>();
        for (int i = 0; i < ol.size(); i++)
        {
            String thisObject = (String) ol.elementAt(i);
            String newPath;
            if (curPath.equals("."))
            newPath = thisObject;
            else
            newPath = curPath + File.separator + thisObject;
            if ((f = new File(newPath)).isDirectory())
            addNodes(curDir, f);
            else
            files.addElement(thisObject);
        }
       for (int fnum = 0; fnum < files.size(); fnum++)
       curDir.add(new DefaultMutableTreeNode(files.elementAt(fnum)));
       return curDir;
    }

  public static void main(String[] av)
  {

    JFrame frame = new JFrame("Drive View");
    Container cp = frame.getContentPane();
    if (av.length == 0) 
    {
      cp.add(new DriveTree(new File(".")));
    }
    else
    {
      cp.setLayout(new BoxLayout(cp, BoxLayout.X_AXIS));
      for (int i = 0; i < av.length; i++)
      cp.add(new DriveTree(new File(av[i])));
    }
    frame.pack();
    frame.setVisible(true);
    frame.setSize(300,500);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }
}
