/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fsmv.util;

/**
 *
 * @author Narwane
 */
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import com.mxgraph.layout.mxCircleLayout;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.util.mxConstants;
import com.mxgraph.view.mxGraph;
import com.mxgraph.view.mxStylesheet;
import fsmv.SingleFSMv;
import fsmv.FSMvState;
import fsmv.FSMvTransition;
import java.awt.Color;
import java.awt.Font;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.List;


public class CreateAutomata {

    public static final String MY_CUSTOM_VERTEX_STYLE = "MY_CUSTOM_VERTEX_STYLE";
    public static final String MY_CUSTOM_EDGE_STYLE = "MY_CUSTOM_EDGE_STYLE";

    public mxGraphComponent getAutomata(SingleFSMv fsmv) {


        mxGraph graph = new mxGraph();
        Object parent = graph.getDefaultParent();
        graph.getModel().beginUpdate();
        //mxIGraphModel gm = new mxGraphModel();
        //graph.setModel(gm);

        Hashtable<String, Object> style;
        mxStylesheet stylesheet = graph.getStylesheet();

        // base style
        Hashtable<String, Object> baseStyle = new Hashtable<String, Object>();
        baseStyle.put(mxConstants.STYLE_STROKECOLOR, "#0C15C8");


        style = new Hashtable<String, Object>(baseStyle);
        style.put(mxConstants.STYLE_FILLCOLOR, "#0CC812");
        style.put(mxConstants.STYLE_STROKEWIDTH, 1);
        style.put(mxConstants.STYLE_SHAPE, "ellipse");
        stylesheet.putCellStyle(MY_CUSTOM_VERTEX_STYLE, style);


        // custom edge style
        style = new Hashtable<String, Object>(baseStyle);
        style.put(mxConstants.STYLE_STROKEWIDTH, 1);
        style.put(mxConstants.EDGESTYLE_LOOP, "loopEdgeStyle");
        style.put(mxConstants.SHAPE_CURVE, "curve");
        stylesheet.putCellStyle(MY_CUSTOM_EDGE_STYLE, style);

        Map<String, Object> stateMap = new HashMap<>();
        try {
            List<FSMvState> statesVector = fsmv.getStates();

            Iterator<FSMvState> statesItr = statesVector.iterator();
            while (statesItr.hasNext()) {
                FSMvState tempState = statesItr.next();
                Object temp = graph.insertVertex(parent, null, tempState, 100, 250, 25,
                        25, MY_CUSTOM_VERTEX_STYLE);
                stateMap.put(tempState.getState(), temp);
            }

            List<FSMvTransition> transitionVector = fsmv.getTransitions();
            Iterator<FSMvTransition> transitionItr = transitionVector.iterator();
            while (transitionItr.hasNext()) {
                FSMvTransition tempTransition = transitionItr.next();
                //graph.insertEdge(parent, null,tempTransition.getEvents()+":"+tempTransition.getVd(), stateMap.get(tempTransition.getSource().getState()), stateMap.get(tempTransition.getDestination().getState()),
                //        "edgeStyle=elbowEdgeStyle;elbow=horizontal;orthogonal=0;" + "entryX=0;entryY=0;entryPerimeter=1;");
                //System.out.println("Predicates: "+tempTransition.getVd());
                graph.insertEdge(parent, null, tempTransition.getEvent().getEvent() + ":" + tempTransition.getVd().getVd().getEqu(), stateMap.get(tempTransition.getSource().getState()), stateMap.get(tempTransition.getDestination().getState()), MY_CUSTOM_EDGE_STYLE);
            }
        } finally {
            graph.getModel().endUpdate();
        }

        mxCircleLayout layout = new mxCircleLayout(graph, 175);
        layout.execute(parent);

        mxGraphComponent graphComponent = new mxGraphComponent(graph);
        graphComponent.setBackground(Color.WHITE);
        graphComponent.setFont(new Font("Arial", Font.BOLD, 14));

        return graphComponent;
    }

    /*
    public static void main(String[] args) {
    CreateAutomata frame = new CreateAutomata();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setSize(400, 320);
    frame.setVisible(true);
    }*/
}
