package fsmv.util;

import java.io.File;

/**
 * A FileFilter which will accept directories only, as determined by the
 * java.io.File.isDirectory() method.
 *
 * @author Havard Rast Blok
 *
 */
public class DirectoryFileFilter extends javax.swing.filechooser.FileFilter
    implements java.io.FileFilter {

    private static final String DESCRIPTION = "Directories only";

    public DirectoryFileFilter() {
        //do nothing
    }

    /* (non-Javadoc)
     * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
     */
    public boolean accept(File f) {
        return f.isDirectory();
    }

    /* (non-Javadoc)
     * @see javax.swing.filechooser.FileFilter#getDescription()
     */
    public String getDescription() {
        return DESCRIPTION;
    }


}