/*
 * FSMvGUIView.java
 */
package fsmvgui;

import com.mxgraph.swing.mxGraphComponent;
import eu.beesoft.gaia.swing.JCloseableTabbedPane;

import fsmv.ComposedFSMv;
import java.awt.event.ItemEvent;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;

import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import java.util.logging.Level;
import java.util.logging.Logger;

import fsmv.phi.Configuration;
import fsmv.phi.Phi;
import fsmv.phi.PhiCouple;
import fsmv.util.CreateAutomata;
import fsmv.util.CreateProjectionAutomata;
import fsmvVerifier.Verifier;
import fsmv.FSMv;
import fsmv.FSMvVariable;
import fsmv.SingleFSMv;
import java.awt.Component;

import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ItemListener;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.text.PlainDocument;
import org.bounce.text.ScrollableEditorPanel;
import org.bounce.text.xml.XMLEditorKit;
import org.bounce.text.xml.XMLStyleConstants;

/**
 * The application's main frame.
 */
public class FSMvGUIView extends FrameView {


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JEditorPane editorPaneOutput;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JEditorPane jEditorPane1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JPanel mainPanel;
    private eu.beesoft.gaia.swing.JCloseableTabbedPane mainTabbedPane;
    private javax.swing.JPanel mainWorkingPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JTabbedPane projectTabbedPane;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables
    
    
    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;
    private JDialog aboutBox;
    private RowListener rowListener;
    
    
    private File selectedDirPath;
    private File fileSelected;

    private Verifier verifier;
    private Map<String,JEditorPane> openFiles;
    private Map<String,String> openFilePaths;
	
    public FSMvGUIView(SingleFrameApplication app) 
    {
        super(app);
        initComponents();
        mainTabbedPane.setAutoClose(true);
        jScrollPane2.add(mainTabbedPane);
        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {

            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String) (evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer) (evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });
        
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = FSMvGUIApp.getApplication().getMainFrame();
            aboutBox = new FSMvGUIAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        FSMvGUIApp.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jButton2 = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jPanel2 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        projectTabbedPane = new javax.swing.JTabbedPane();
        mainWorkingPanel = new javax.swing.JPanel();
        mainTabbedPane = new eu.beesoft.gaia.swing.JCloseableTabbedPane();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        editorPaneOutput = new javax.swing.JEditorPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jEditorPane1 = new javax.swing.JEditorPane();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        mainPanel.setName("mainPanel"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N

        jToolBar1.setRollover(true);
        jToolBar1.setName("jToolBar1"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance().getContext().getActionMap(FSMvGUIView.class, this);
        jButton1.setAction(actionMap.get("loadProject")); // NOI18N
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance().getContext().getResourceMap(FSMvGUIView.class);
        jButton1.setIcon(resourceMap.getIcon("jButton1.icon")); // NOI18N
        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setToolTipText(resourceMap.getString("jButton1.toolTipText")); // NOI18N
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setName("jButton1"); // NOI18N
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButton1);

        jSeparator2.setName("jSeparator2"); // NOI18N
        jToolBar1.add(jSeparator2);

        jButton2.setAction(actionMap.get("confirmDtoR")); // NOI18N
        jButton2.setIcon(resourceMap.getIcon("jButton2.icon")); // NOI18N
        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setToolTipText(resourceMap.getString("jButton2.toolTipText")); // NOI18N
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setName("jButton2"); // NOI18N
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButton2);

        jSeparator3.setName("jSeparator3"); // NOI18N
        jToolBar1.add(jSeparator3);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 888, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, Short.MAX_VALUE)
        );

        jPanel2.setName("jPanel2"); // NOI18N

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setName("jSplitPane1"); // NOI18N

        jSplitPane2.setBackground(resourceMap.getColor("jSplitPane2.background")); // NOI18N
        jSplitPane2.setDividerLocation(200);
        jSplitPane2.setAutoscrolls(true);
        jSplitPane2.setName("jSplitPane2"); // NOI18N

        projectTabbedPane.setAutoscrolls(true);
        projectTabbedPane.setFont(resourceMap.getFont("projectTabbedPane.font")); // NOI18N
        projectTabbedPane.setName("projectTabbedPane"); // NOI18N
        jSplitPane2.setLeftComponent(projectTabbedPane);

        mainWorkingPanel.setName("mainWorkingPanel"); // NOI18N

        mainTabbedPane.setBackground(resourceMap.getColor("mainTabbedPane.background")); // NOI18N
        mainTabbedPane.setAutoClose(true);
        mainTabbedPane.setAutoscrolls(true);
        mainTabbedPane.setName("mainTabbedPane"); // NOI18N

        javax.swing.GroupLayout mainWorkingPanelLayout = new javax.swing.GroupLayout(mainWorkingPanel);
        mainWorkingPanel.setLayout(mainWorkingPanelLayout);
        mainWorkingPanelLayout.setHorizontalGroup(
            mainWorkingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 687, Short.MAX_VALUE)
        );
        mainWorkingPanelLayout.setVerticalGroup(
            mainWorkingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)
        );

        jSplitPane2.setRightComponent(mainWorkingPanel);

        jSplitPane1.setTopComponent(jSplitPane2);

        jTabbedPane2.setFont(resourceMap.getFont("jTabbedPane2.font")); // NOI18N
        jTabbedPane2.setName("jTabbedPane2"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        editorPaneOutput.setBackground(resourceMap.getColor("editorPaneOutput.background")); // NOI18N
        editorPaneOutput.setFont(resourceMap.getFont("editorPaneOutput.font")); // NOI18N
        editorPaneOutput.setForeground(resourceMap.getColor("editorPaneOutput.foreground")); // NOI18N
        editorPaneOutput.setName("editorPaneOutput"); // NOI18N
        jScrollPane1.setViewportView(editorPaneOutput);

        jTabbedPane2.addTab(resourceMap.getString("jScrollPane1.TabConstraints.tabTitle"), jScrollPane1); // NOI18N

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        jEditorPane1.setEditable(false);
        jEditorPane1.setName("jEditorPane1"); // NOI18N
        jScrollPane2.setViewportView(jEditorPane1);

        jTabbedPane2.addTab(resourceMap.getString("jScrollPane2.TabConstraints.tabTitle"), jScrollPane2); // NOI18N

        jSplitPane1.setRightComponent(jTabbedPane2);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        menuBar.setFont(resourceMap.getFont("menuBar.font")); // NOI18N
        menuBar.setMaximumSize(new java.awt.Dimension(150, 32769));
        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setBorder(new javax.swing.border.SoftBevelBorder(0));
        fileMenu.setForeground(resourceMap.getColor("fileMenu.foreground")); // NOI18N
        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setFont(resourceMap.getFont("fileMenu.font")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        jMenuItem1.setAction(actionMap.get("loadProject")); // NOI18N
        jMenuItem1.setFont(resourceMap.getFont("fileLoadProjects.font")); // NOI18N
        jMenuItem1.setText(resourceMap.getString("fileLoadProjects.text")); // NOI18N
        jMenuItem1.setName("fileLoadProjects"); // NOI18N
        fileMenu.add(jMenuItem1);

        jMenuItem4.setAction(actionMap.get("saveButton")); // NOI18N
        jMenuItem4.setFont(resourceMap.getFont("jMenuItem4.font")); // NOI18N
        jMenuItem4.setText(resourceMap.getString("jMenuItem4.text")); // NOI18N
        jMenuItem4.setName("jMenuItem4"); // NOI18N
        fileMenu.add(jMenuItem4);

        jMenuItem7.setAction(actionMap.get("addFeature")); // NOI18N
        jMenuItem7.setText(resourceMap.getString("jMenuItem7.text")); // NOI18N
        jMenuItem7.setName("jMenuItem7"); // NOI18N
        fileMenu.add(jMenuItem7);

        jMenuItem8.setAction(actionMap.get("saveOutputButton")); // NOI18N
        jMenuItem8.setText(resourceMap.getString("jMenuItem8.text")); // NOI18N
        jMenuItem8.setName("jMenuItem8"); // NOI18N
        fileMenu.add(jMenuItem8);

        jMenuItem9.setAction(actionMap.get("onExit")); // NOI18N
        jMenuItem9.setText(resourceMap.getString("jMenuItem9.text")); // NOI18N
        jMenuItem9.setName("jMenuItem9"); // NOI18N
        fileMenu.add(jMenuItem9);

        menuBar.add(fileMenu);

        jMenu1.setAction(actionMap.get("splConformance")); // NOI18N
        jMenu1.setBorder(new javax.swing.border.SoftBevelBorder(0));
        jMenu1.setForeground(resourceMap.getColor("jMenu1.foreground")); // NOI18N
        jMenu1.setText(resourceMap.getString("jMenu1.text")); // NOI18N
        jMenu1.setFont(resourceMap.getFont("jMenu1.font")); // NOI18N
        jMenu1.setName("jMenu1"); // NOI18N

        jMenuItem2.setAction(actionMap.get("confirmDtoR")); // NOI18N
        jMenuItem2.setFont(resourceMap.getFont("jMenuItem2.font")); // NOI18N
        jMenuItem2.setText(resourceMap.getString("jMenuItem2.text")); // NOI18N
        jMenuItem2.setName("jMenuItem2"); // NOI18N
        jMenu1.add(jMenuItem2);

        jMenuItem3.setAction(actionMap.get("splConformance")); // NOI18N
        jMenuItem3.setFont(resourceMap.getFont("jMenuItem3.font")); // NOI18N
        jMenuItem3.setText(resourceMap.getString("jMenuItem3.text")); // NOI18N
        jMenuItem3.setName("jMenuItem3"); // NOI18N
        jMenu1.add(jMenuItem3);

        menuBar.add(jMenu1);

        jMenu2.setBorder(new javax.swing.border.SoftBevelBorder(0));
        jMenu2.setText(resourceMap.getString("jMenu2.text")); // NOI18N
        jMenu2.setFont(resourceMap.getFont("jMenu2.font")); // NOI18N
        jMenu2.setName("jMenu2"); // NOI18N

        jMenuItem6.setAction(actionMap.get("convertExpression")); // NOI18N
        jMenuItem6.setFont(resourceMap.getFont("jMenuItem6.font")); // NOI18N
        jMenuItem6.setText(resourceMap.getString("jMenuItem6.text")); // NOI18N
        jMenuItem6.setName("jMenuItem6"); // NOI18N
        jMenu2.add(jMenuItem6);

        jMenuItem5.setAction(actionMap.get("generateDesign")); // NOI18N
        jMenuItem5.setFont(resourceMap.getFont("jMenuItem5.font")); // NOI18N
        jMenuItem5.setText(resourceMap.getString("jMenuItem5.text")); // NOI18N
        jMenuItem5.setName("jMenuItem5"); // NOI18N
        jMenu2.add(jMenuItem5);

        menuBar.add(jMenu2);

        helpMenu.setBorder(new javax.swing.border.SoftBevelBorder(0));
        helpMenu.setForeground(resourceMap.getColor("helpMenu.foreground")); // NOI18N
        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setFont(resourceMap.getFont("helpMenu.font")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setFont(resourceMap.getFont("aboutMenuItem.font")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 900, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 716, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents
    
    @Action
    public void loadProject() {
        JFileChooser fc = new JFileChooser("../caseStudy");
        //fc.addChoosableFileFilter(new ExtensionFileFilter("FSMv", "*.properties"));
        int returnVal = fc.showOpenDialog(mainPanel); //Where frame is the parent component
        if(openFiles==null){
            openFiles=new HashMap<String, JEditorPane>();
        }
        if(openFilePaths==null){
            openFilePaths = new HashMap<String,String>();
        }
        if (returnVal == JFileChooser.APPROVE_OPTION)
        {
            fileSelected = fc.getSelectedFile();
            selectedDirPath = fc.getCurrentDirectory();
            
            reloadProject(true);
            
            
        } else 
        {
            System.out.println("User pressed canceled.");
        }
    }
    
    private void reloadProject(boolean renewVerifier)
    {
        MutableTreeNode root = new DefaultMutableTreeNode(selectedDirPath.getName());
            JTree jTreeSample = new JTree();
            jTreeSample.setCellRenderer(new CustomIconRenderer());
            jTreeSample.setRootVisible(true);
            //root.insert(node, 0);
            TreeModel model1 = new DefaultTreeModel(root);
            jTreeSample.setModel(model1);
            jTreeSample.addTreeSelectionListener(new TreeSelectionListener() {
                
                public void valueChanged(TreeSelectionEvent e) {
                    TreePath path = e.getNewLeadSelectionPath();
                    if (path == null) {
                        return;
                    }
                    DefaultMutableTreeNode curNode = (DefaultMutableTreeNode) path.getLastPathComponent();
                    Object nodes[] = path.getPath();
                    String dirStr = selectedDirPath.getAbsolutePath().toString()+File.separator;
                    for (int i = 1; i < nodes.length; i++) {
                        DefaultMutableTreeNode node = (DefaultMutableTreeNode) nodes[i];
                        //the user object will hold the directory name
                        dirStr += (String) node.getUserObject();
                        //System.out.println("DirStr 1:" + dirStr);
                        //add the platform independent directory separator character
                        dirStr += File.separator;
                        //System.out.println("DirStr 2:" + dirStr);
                    }
                    addChildren(curNode, dirStr);
                }
            });
            JScrollPane pane = new JScrollPane(jTreeSample);
            projectTabbedPane.add("Project:" + selectedDirPath.getName(), pane);
            
            try {
                
                if(renewVerifier)
                {
                    //Build the verifier object
                    this.verifier=new Verifier(selectedDirPath.getAbsolutePath(), fileSelected);
                }
                else
                {
                    //add features
                    verifier.addFeaturePairsFromFile(fileSelected);
                }
                
                if (verifier != null && !verifier.getListOfFeature().isEmpty())
                {
                    Object col[] = {"Id","Type","Design (FSMd)", "Requirement (FSMr)"};
                    Object[][] data = new Object[verifier.getListOfFeature().size()][col.length];
                    int count = 0;
                    for (Entry<FSMv, FSMv> entry : verifier.getListOfFeature().entrySet()) {
                        //System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());
                        
                        data[count][0]=count+1;
                        
                        data[count][1] = "";
                        if(entry.getKey() instanceof SingleFSMv)
                            data[count][1] += "FSMd";
                        else data[count][1] += "Composed FSMd";
                        data[count][1] += " <-> ";
                        if(entry.getValue() instanceof SingleFSMv)
                            data[count][1] += "FSMr";
                        else data[count][1] += "ComposedFSMr";
                        data[count][1] += "";
                        
                        data[count][2] = entry.getKey().getName();
                        data[count][3] = entry.getValue().getName();
                        count++;
                    }
                    
                    TableModel model = new DefaultTableModel(data, col);
                    
                    JTable fsmvConfig = new JTable(model) {
                        
                        private static final long serialVersionUID = -5321345702024695381L;
                        public boolean isCellEditable(int rowIndex, int colIndex) {
                            return false; //Disallow the editing of any cell
                        }
                    };
                    
                    fsmvConfig.setAutoCreateRowSorter(true);
                    fsmvConfig.setAutoResizeMode(1);
                    fsmvConfig.setFont(new Font("Arial", Font.PLAIN, 14));
                    ListSelectionModel selectionModel = fsmvConfig.getSelectionModel();
                    selectionModel.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                    rowListener = new RowListener(fsmvConfig);
                    selectionModel.addListSelectionListener(rowListener);
                    fsmvConfig.setSelectionBackground(Color.BLUE);
                    fsmvConfig.setSelectionForeground(Color.WHITE);
                    fsmvConfig.setShowGrid(true);
                    JTableHeader header = fsmvConfig.getTableHeader();
                    header.setFont(new Font("Arial", Font.BOLD, 14));
                    header.setAutoscrolls(true);
                    JScrollPane pane2 = new JScrollPane(fsmvConfig);
                    mainTabbedPane.setFont(new Font("Arial", Font.PLAIN, 12));
                    String strTemp[] = fileSelected.getName().split("\\.");
                    pane2.setName(strTemp[0] + " Mapping");
                    mainTabbedPane.add(pane2.getName(), pane2);
                    mainTabbedPane.setSelectedComponent(pane2);
                    
                    fsmvConfig.getColumn(col[0]).setWidth(5);
                }
                else 
                {
                    JOptionPane.showMessageDialog(mainPanel, "No Records Found.");
                }
                
            }
            catch (IOException e)
            {
                JOptionPane.showMessageDialog(mainPanel, "Exception occured in calling service.", "PMUC Exception", JOptionPane.ERROR_MESSAGE);
                Logger.getLogger(FSMvGUIView.class.getName()).log(Level.SEVERE, null, e);
            }
    }
    
    protected void addChildren(MutableTreeNode node, String path) {
        File dir = new File(path);
        File subDirs[] = dir.listFiles();
        //System.out.println("Subdir:" + subDirs);
        if (subDirs != null) {
            int i = 0;
            for (File f : subDirs) {
                if(f.getPath().toLowerCase().endsWith("fsmr") || f.getPath().toLowerCase().endsWith("fsmd") 
                        || f.getPath().toLowerCase().endsWith(".properties") || f.getPath().toString().endsWith(".xml") ||
                        f.getPath().toLowerCase().endsWith(".tvl")){
                MutableTreeNode child = new DefaultMutableTreeNode(f.getName());
                node.insert(child, i++);
                }
            }
        }
        if (subDirs == null) {
            path = path.substring(0, path.length()-1);
            try {
                FileInputStream fr = new FileInputStream(path);
                InputStreamReader isr = new InputStreamReader(fr, "UTF-8");
                BufferedReader reader = new BufferedReader(isr);
                StringBuilder buffer = new StringBuilder();

                String line = null;
                while ((line = reader.readLine()) != null) {
                    buffer.append(line + "\n");
                }

                reader.close();            
                JEditorPane editor = new JEditorPane(); 
                openFiles.put(dir.getName(), editor);
                openFilePaths.put(dir.getName(), path);
                if(path.toLowerCase().endsWith(".xml")){
                    XMLEditorKit kit = new XMLEditorKit();
                    editor.setEditorKit( kit);
                    File file = new File(path);
                    editor.read(new FileReader(file), file);
                    editor.setFont(new Font("Courier", Font.BOLD, 14));
                    editor.getDocument().putProperty(PlainDocument.tabSizeAttribute,new Integer(4));
                    kit.setAutoIndentation(true);
                    kit.setTagCompletion(true);
                    editor.getDocument().putProperty(XMLEditorKit.ERROR_HIGHLIGHTING_ATTRIBUTE, new Boolean(true));
                    kit.setStyle(XMLStyleConstants.ATTRIBUTE_NAME, new Color(255, 0, 0),Font.BOLD);
                    ScrollableEditorPanel editorPanel = new ScrollableEditorPanel(editor);
                    JScrollPane scroller = new JScrollPane( editorPanel);
                    scroller.setName(dir.getName());
                    mainTabbedPane.add(scroller.getName(), scroller);
                    mainTabbedPane.setSelectedComponent(scroller);
                }else{
                    File file = new File(path);
                    editor.read(new FileReader(file), file);
                    editor.setFont(new Font("Courier", Font.BOLD, 14));
                    editor.getDocument().putProperty(PlainDocument.tabSizeAttribute,new Integer(4));
                    editor.getDocument().putProperty(XMLEditorKit.ERROR_HIGHLIGHTING_ATTRIBUTE, new Boolean(true));
                    JScrollPane scroller = new JScrollPane( editor);
                    scroller.setName(dir.getName());
                    mainTabbedPane.add(scroller.getName(), scroller);
                    mainTabbedPane.setSelectedComponent(scroller);
                }
            } catch (IOException ex) {
                Logger.getLogger(FSMvGUIView.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
    }
    
    @Action
    public void confirmDtoR() 
    {
        editorPaneOutput.setFont(new Font("Arial", Font.BOLD, 12));
        editorPaneOutput.setText("");
        //System.out.println("enter verifier main");
        
        //Get the couple DR from names
        String fsmd_name=rowListener.getSelectedRowData()[2];
        FSMv req_machine=null;
        FSMv des_machine=null;
        
        for(Entry<FSMv,FSMv> entry: verifier.getListOfFeature().entrySet())
        {
            if(fsmd_name.startsWith(entry.getKey().getName()))
            {
                des_machine=entry.getKey();
                req_machine=entry.getValue();
            }
        }
        
        
        if(des_machine==null)
        {
            editorPaneOutput.setForeground(Color.red);
            System.out.println("The feature "+rowListener.getSelectedRowData()[1]+" has not been found.");
            return;
        }
        
        if(des_machine instanceof SingleFSMv && req_machine instanceof SingleFSMv)
        {
            //Draw
            CreateAutomata automata = new CreateAutomata();
            mainTabbedPane.add("FSMr: " + req_machine.getName(), new JScrollPane(automata.getAutomata((SingleFSMv)req_machine)));
            mainTabbedPane.add("FSMd: " + des_machine.getName(), new JScrollPane(automata.getAutomata((SingleFSMv)des_machine)));
        }
        
        //Do the verification
        mainPanel.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        Phi phi= verifier.RefinementChecking(des_machine);
        
               
        this.printResult(phi);
    }

    @Action
    public void splConformance() 
    {
        
        editorPaneOutput.setFont(new Font("Arial", Font.BOLD, 12));
        editorPaneOutput.setText("");
        mainPanel.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        verifier.FullRefinementChecking();
        
        for(Phi phi: verifier.getListOfPhi())
        {
            this.printResult(phi);
        }
        String[] config = verifier.splLevelChecking();
        
        editorPaneOutput.setText(editorPaneOutput.getText()
                               + "*******************************\n"
                               + "******SPL level checking*******\n"
                               + "*******************************\n");
        
        if(config.length==1 && 
                ( config[0].startsWith("There is no invalid configuration.")
                ||
                  config[0].equals("Error occured.")))
            
        {
            editorPaneOutput.setForeground(new Color(0, 0, 204));
            editorPaneOutput.setText(editorPaneOutput.getText() + config[0]);
        }
        else
        {
            editorPaneOutput.setForeground(Color.red);
             editorPaneOutput.setText(editorPaneOutput.getText()+"\n The following configuration is invalid (other configurations may also be invalid)");
             editorPaneOutput.setText(editorPaneOutput.getText()+"\n <configuration>");
             
             for(String var:config)
             {
                 if(!var.equals(""))
                 {
                    editorPaneOutput.setText(editorPaneOutput.getText()+"\n" + var);
                 }
             }

             editorPaneOutput.setText(editorPaneOutput.getText()+"\n </configuration>");
        }
    }
        
    @Action
    public void saveButton() {
        Component c = mainTabbedPane.getSelectedComponent();
        JEditorPane ep = null;
        String path = null;
        if(openFiles.containsKey(c.getName())){
            ep=openFiles.get(c.getName());
        }else{
            return;
        }
        path = openFilePaths.get(c.getName());
        String str = ep.getText();
        try {
            FileWriter fw = new FileWriter(path);
            if (str != null && !str.trim().equals("")) {
                fw.write(str.trim());
            }
            fw.close();
            JOptionPane.showMessageDialog(mainPanel, "File Saved successfully.");
        } catch (IOException ex) {
            Logger.getLogger(FSMvGUIView.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    
    @Action
    public void saveOutputButton() {
        String str = editorPaneOutput.getText();
        try {
            FileWriter fw = new FileWriter(selectedDirPath + "/SPLEnD_log.txt");
            if (str != null && !str.trim().equals("")) {
                fw.write(str.trim());
            }
            fw.close();
            JOptionPane.showMessageDialog(mainPanel, "Output log Saved successfully.");
        } catch (IOException ex) {
            Logger.getLogger(FSMvGUIView.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    private void printResult(Phi phi) 
    {
        StringBuilder text=new StringBuilder("");
        //Print the result of the verification
        mainPanel.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        
        text.append("*****************\nSelected Feature:")
            .append(phi.getDesign().getName())
            .append("\n*****************");
        
        text.append("\n\n");
        
        //Print the list of design configurations
        text.append("List of Valid Design Configurations:");
        for (Configuration configuration: phi.getDesign().getListOfValidConfiguration()) 
        {
            text.append("\nConfiguration: [");
            String delim="";
            for (Map.Entry<String, String> entry : configuration.getListOfVariable_value().entrySet()) 
            {
                text.append(delim);
                text.append(entry.getKey())
                        .append("=")
                        .append(entry.getValue());
                delim=", ";
            }
            text.append(" ]");
        }
        text.append("\n\n");
        
        
        //Print the list of requirement configurations
        text.append("List of Valid Requirement Configurations:");
        for (Configuration configuration: phi.getRequirement().getListOfValidConfiguration()) 
        {
            text.append("\nConfiguration: [");
            String delim="";
            for (Map.Entry<String, String> entry : configuration.getListOfVariable_value().entrySet()) {
                text.append(delim);
                text.append(entry.getKey())
                        .append("=")
                        .append(entry.getValue());
                delim=", ";
            }
            text.append(" ]");
        }
        text.append("\n\n");
        
        //Print the conformance mapping
        
        text.append("List of Conformance Mapping:");
        for (PhiCouple phiCouple: phi.getListOfCorrespondanceMapping()) 
        {
            text.append("\nMapping: {[");
            Configuration design = phiCouple.getDesign();
            String delim="";
            for (Map.Entry<String, String> entry : design.getListOfVariable_value().entrySet()) {
                text.append(delim);
                text.append(entry.getKey())
                        .append("=")
                        .append(entry.getValue());
                delim=", ";
            }
            text.append(" ]");

            text.append(", [");
            Configuration requirement = phiCouple.getRequirement();
            delim="";
            for (Map.Entry<String, String> entry : requirement.getListOfVariable_value().entrySet()) 
            {
                text.append(delim);
                text.append(entry.getKey())
                        .append("=")
                        .append(entry.getValue());
                delim=", ";
            }
            text.append(" ]}");
        }
        
        text.append("\n\n");
        
        //If any, print the illegal configurations
        Set<Configuration> illegalConfig = phi.getListOfIllegalConfigurations();
        if (illegalConfig != null && !illegalConfig.isEmpty()) 
        {
            editorPaneOutput.setForeground(Color.red);
            System.out.println("Number of invalid configurations in the design: " + illegalConfig.size());//+"\n\n\n"+result);
            text.append("\nList of invalid configurations:");
            text.append(illegalConfig.size());
            JCloseableTabbedPane illConfigTabbedPane = new JCloseableTabbedPane();
            illConfigTabbedPane.setAutoClose(true);
            illConfigTabbedPane.setAutoscrolls(true);
            CreateProjectionAutomata createProjectionAutomata = new CreateProjectionAutomata();
            int count = 1;
            
            for (Configuration configuration: illegalConfig) 
            {
            	if(phi.getDesign() instanceof SingleFSMv)
                {
                    mxGraphComponent comp = createProjectionAutomata.getProjectionAutomata((SingleFSMv)phi.getDesign(), configuration);
                    mainTabbedPane.add("ill Pro" + count + ":" + phi.getDesign().getName(), comp);
                }
                text.append("\nProjection").append(count).append(": [");
                String delim="";
                for (Map.Entry<String, String> entry : configuration.getListOfVariable_value().entrySet()) 
                {
                    text.append(delim);
                    text.append(entry.getKey()).append("=").append(entry.getValue());
                    delim=", ";
                }
                text.append(" ]");
                count++;
            }
        } else 
        {
            editorPaneOutput.setForeground(new Color(0, 0, 204));
            text.append("There is no invalid configuration in the design");
        }
        
        text.append("\n\n");
        
        //Print the time statistics
        text.append("Execution Time:").append(verifier.getExecutionTime().get(phi.getDesign())).append(" Seconds\n");
        
        text.append("Execution Complete.\n\n\n");
        
        editorPaneOutput.setText(editorPaneOutput.getText()+text);
    }
    
    @Action
    public void convertExpression()
    {
        
        if(this.verifier==null)
            return;
        
        if(this.verifier.getListOfPhi()==null)
            return;
        
        final JDialog dialog=new JDialog(this.getFrame());
        dialog.setTitle("Convert an expression from Requirement to Design");
        JPanel p=new JPanel();
        
        p.setLayout(new GridLayout(3, 1));
        
        JPanel[] ppp={new JPanel(),new JPanel(),new JPanel()};
        
        ppp[0].setLayout(new FlowLayout());
        ppp[1].setLayout(new FlowLayout());
        ppp[2].setLayout(new FlowLayout());
        
        ppp[0].add(new JLabel("Input:"));
        final JTextArea tf_in=new JTextArea(3,70);
        tf_in.setLineWrap(true);
        ppp[0].add(tf_in);
        
        ppp[1].add(new JLabel("Output:"));
        final JTextArea tf_out=new JTextArea(8,70);
        tf_out.setEditable(false);
        tf_out.setLineWrap(true);
        ppp[1].add(tf_out);
        
        JButton buttonConvert=new JButton("Convert");
        JButton buttonProm=new JButton("Convert to Promela");
        JButton buttonClose=new JButton("Close");
        
        buttonClose.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                dialog.setVisible(false);
            }
        });
        
        buttonConvert.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                String converted=verifier.convertExpression(tf_in.getText(),false);
                tf_out.setText(converted);
            }
        });
        
        buttonProm.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                String converted=verifier.convertExpression(tf_in.getText(),true);
                tf_out.setText(converted);
            }
        });
        
        ppp[2].add(buttonConvert);
        ppp[2].add(buttonProm);
        ppp[2].add(buttonClose);
        
        p.add(ppp[0]);
        p.add(ppp[1]);
        p.add(ppp[2]);
        dialog.add(p);
        dialog.setSize(800, 250);
        dialog.setLocation(this.getFrame().getLocation().x+50, this.getFrame().getLocation().y+50);
        dialog.setVisible(true);
    }
    
    @Action
    public void generateDesign()
    {
        //System.out.println("generateDesign()");
        
        //Get a config
            
            final JDialog mcbox=new JDialog(this.getFrame(), "Model cheking with SPIN", false);
            //mcbox.setLayout(new GridLayout(3, 1));
            //mcbox.setLayout(new FlowLayout());
        
            final ComposedFSMv cfsmv=new ComposedFSMv(new ArrayList<>(verifier.getListOfFeature().keySet()), verifier.getRhod());
            
            List<SingleFSMv> fsmvs=cfsmv.getSingleFSMvs();
            
            mcbox.setLayout(new GridLayout(1+fsmvs.size()+3, 1));
            
            final JLabel nbConfLabel=new JLabel("Number of compatible configuration:"+cfsmv.getListOfValidConfiguration().size());
            final JPanel propPanel=new JPanel();
            propPanel.setLayout(new FlowLayout());
            propPanel.add(nbConfLabel);
            
            mcbox.add(propPanel);
            
            final JLabel[] labelName=new JLabel[fsmvs.size()];
            final JPanel[] panelComboBoxes=new JPanel[fsmvs.size()];
            final JPanel[] panelFSMd=new JPanel[fsmvs.size()];
            
            List<MyJComboBox> mjcbs=new ArrayList<>();
            
            for(int i=0;i<fsmvs.size();i++)
            {
                
                    labelName[i]=new JLabel(fsmvs.get(i).getName());
                    panelComboBoxes[i]=new JPanel();
                    panelComboBoxes[i].setLayout(new FlowLayout());//new GridLayout(1, fsmvs.get(i).getVariables().size()));
                    for(FSMvVariable variable: fsmvs.get(i).getVariables())
                    {
                        JPanel insidePanel=new JPanel();
                        insidePanel.setLayout(new GridLayout(2,1));
                        insidePanel.add(new JLabel(variable.getV_name()));
                        Vector<String> v=new Vector<>(variable.getValues());
                        v.add(0, "");
                        MyJComboBox jcb=new MyJComboBox(variable,v);
                        mjcbs.add(jcb);
                        insidePanel.add(jcb);
                        panelComboBoxes[i].add(insidePanel);
                    }
                    panelFSMd[i]= new JPanel();
                    panelFSMd[i].setLayout(new FlowLayout());
                    panelFSMd[i].add(labelName[i]);
                    panelFSMd[i].add(panelComboBoxes[i]);
                    mcbox.add(panelFSMd[i]);
            }
            
            
            final MyItemListener myItemListener=new MyItemListener(nbConfLabel, mjcbs, cfsmv.getListOfValidConfiguration());
            
                
            
            
            final JLabel labelProp=new JLabel("Enter the LTL property to check following <spin -f> syntax (We will negate it for you):");
            final JTextArea property= new JTextArea(50,3);
            
            //final JPanel propPanel=new JPanel();
            //propPanel.setLayout(new FlowLayout());
            mcbox.add(labelProp);
            mcbox.add(property);
            
            final JButton ok= new JButton("Check with SPIN");
            final JButton cancel= new JButton("Cancel");
            
            final JPanel buttonPanel=new JPanel();
            buttonPanel.setLayout(new FlowLayout());
            buttonPanel.add(ok);
            buttonPanel.add(cancel);
            
            
            //mcbox.add(confPanel);
            //mcbox.add(propPanel);
            mcbox.add(buttonPanel);
            
            
            cancel.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                mcbox.setVisible(false);
            }
        });
            
            ok.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                
                String prop=property.getText();
                if(prop.equals(""))
                    return;
                
                Configuration conf=myItemListener.getSelectedConfiguration();
                
                if(conf==null)
                    return;
                
                String text=verifier.generateDesign(conf, prop);
                
                if(text==null || !text.startsWith("<Error>"))
                    mcbox.setVisible(false);
                
                editorPaneOutput.setText(editorPaneOutput.getText()+text);
            }
        });
            
            mcbox.pack();
            mcbox.setLocation(this.getFrame().getLocation().x+10, this.getFrame().getLocation().y+10);
            mcbox.setVisible(true);
            
            
    }
    
    final class MyItemListener implements ItemListener
    {
        
        private List<Configuration> selectedConfiguration;
        private JLabel nbConfLabel;
        private final List<MyJComboBox> mjcbs;
        private final List<Configuration> listAllConf;
        
        
        public MyItemListener(JLabel confLabel,List<MyJComboBox> mjcbs, List<Configuration> listAllConf)
        {
            this.nbConfLabel=confLabel;
            this.mjcbs=mjcbs;
            this.listAllConf=listAllConf;
            for(MyJComboBox jcb:mjcbs)
               jcb.addItemListener(this);
        }
        
        @Override
        public void itemStateChanged(ItemEvent e) 
        {
            //System.out.println("MyItemListener.itemStateChanged()");
            findSelectedConfiguration();
            nbConfLabel.setText("Number of compatible configuration:"+selectedConfiguration.size());
        }
        
        private void findSelectedConfiguration()
        {
            selectedConfiguration=new ArrayList<>();
            
            for(Configuration conf:listAllConf)
            {
                boolean compatible=true;
                for(MyJComboBox cb:mjcbs)
                {
                    if(cb.getSelectedItem().equals(""))
                        continue;
                    
                    String selectedValue=(String)cb.getSelectedItem();
                    
                    for(Entry<String,String> entry: conf.getListOfVariable_value().entrySet())
                    {
                        boolean found=false;
                        if(entry.getKey().equals(cb.var.getQualifiedName()))
                        {
                            found=true;
                            if(entry.getValue().equals(selectedValue))
                                continue;
                            else compatible=false;
                        }
                        if(found)
                            break;
                    }
                    
                    if(!compatible)
                        break;
                }
                if(compatible)
                    selectedConfiguration.add(conf);
            }
        }
        
        public Configuration getSelectedConfiguration()
        {
            if(selectedConfiguration==null ||selectedConfiguration.isEmpty())
                return null;
            return selectedConfiguration.get(0);
        }
        
    }
    
    @SuppressWarnings("serial")
	final class MyJComboBox extends JComboBox<String>
    {
        FSMvVariable var;
        MyJComboBox(FSMvVariable var, Vector<String> values)
        {
            super(values);
            this.var=var;
        }
    }

    @Action
    public void addFeature() 
    {
        if(this.verifier==null)
            return;
        
        final JLabel text=new JLabel("Enter a feature pair:");
        final JTextField field=new JTextField("f_des=f_req",50);
        final JButton buttonOk=new JButton("Add");
        final JButton buttonC=new JButton("Cancel");
        final JDialog box=new JDialog(this.getFrame(), true);
        
        final Verifier _verifier=this.verifier;
        //final File selected = this.fileSelected;
        
        box.setLayout(new FlowLayout());
        box.add(text);
        box.add(field);
        box.add(buttonOk);
        box.add(buttonC);
        
        buttonC.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                box.setVisible(false);
            }
        });
        
        buttonOk.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                box.setVisible(false);
                if(_verifier.addFeaturePairFromTextLine(field.getText().trim()))
                {
                    try {
                        try (BufferedWriter bw = new BufferedWriter(new FileWriter(fileSelected,true))) {
                            bw.newLine();
                            bw.append(field.getText().trim());
                        }
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }
                    //Close the opened project, same on me
                    projectTabbedPane.remove(0);
                    mainTabbedPane.remove(0);
                    reloadProject(false);
                    
                }
            }
        });
        box.pack();
        box.setLocation(this.getFrame().getLocation().x+10, this.getFrame().getLocation().y+10);
        box.setVisible(true);
    }

    @Action
    public void onExit() {
    }

    @Action
    public void refreshProject() {
    JFileChooser fc = new JFileChooser("../caseStudy");
        //fc.addChoosableFileFilter(new ExtensionFileFilter("FSMv", "*.properties"));
        int returnVal = fc.showOpenDialog(mainPanel); //Where frame is the parent component
        if(openFiles==null){
            openFiles=new HashMap<String, JEditorPane>();
        }
        if(openFilePaths==null){
            openFilePaths = new HashMap<String,String>();
        }
        if (returnVal == JFileChooser.APPROVE_OPTION)
        {
            fileSelected = fc.getSelectedFile();
            final File dir = fc.getCurrentDirectory();
            selectedDirPath = fc.getCurrentDirectory();
            //MutableTreeNode root = new DefaultMutableTreeNode(dir.getName());
            JTree jTreeSample = new JTree();
            jTreeSample.setCellRenderer(new CustomIconRenderer());
            jTreeSample.setRootVisible(true);
            DefaultMutableTreeNode root = new DefaultMutableTreeNode(dir.getName());
            //root.insert(node, 0);
            TreeModel model1 = new DefaultTreeModel(root);
            jTreeSample.setModel(model1);
            jTreeSample.addTreeSelectionListener(new TreeSelectionListener() {
                
                public void valueChanged(TreeSelectionEvent e) {
                    TreePath path = e.getNewLeadSelectionPath();
                    if (path == null) {
                        return;
                    }
                    DefaultMutableTreeNode curNode = (DefaultMutableTreeNode) path.getLastPathComponent();
                    Object nodes[] = path.getPath();
                    String dirStr = dir.getAbsolutePath().toString()+File.separator;
                    for (int i = 1; i < nodes.length; i++) {
                        DefaultMutableTreeNode node = (DefaultMutableTreeNode) nodes[i];
                        //the user object will hold the directory name
                        dirStr += (String) node.getUserObject();
                        //System.out.println("DirStr 1:" + dirStr);
                        //add the platform independent directory separator character
                        dirStr += File.separator;
                        //System.out.println("DirStr 2:" + dirStr);
                    }
                    addChildren(curNode, dirStr);
                }
            });
            JScrollPane pane = new JScrollPane(jTreeSample);
            projectTabbedPane.add("Project:" + dir.getName(), pane);
            try {
                
                //Build the verifier object
                this.verifier=new Verifier(selectedDirPath.getAbsolutePath(), fileSelected);
                
                
                if (verifier != null && !verifier.getListOfFeature().isEmpty())
                {
                    Object col[] = {"Id","Type","Design (FSMd)", "Requirement (FSMr)"};
                    Object[][] data = new Object[verifier.getListOfFeature().size()][col.length];
                    int count = 0;
                    for (Entry<FSMv, FSMv> entry : verifier.getListOfFeature().entrySet()) {
                        //System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());
                        
                        data[count][0]=count+1;
                        
                        data[count][1] = "";
                        if(entry.getKey() instanceof SingleFSMv)
                            data[count][1] += "FSMd";
                        else data[count][1] += "Composed FSMd";
                        data[count][1] += " <-> ";
                        if(entry.getValue() instanceof SingleFSMv)
                            data[count][1] += "FSMr";
                        else data[count][1] += "ComposedFSMr";
                        data[count][1] += "";
                        
                        data[count][2] = entry.getKey().getName();
                        data[count][3] = entry.getValue().getName();
                        count++;
                    }
                    
                    TableModel model = new DefaultTableModel(data, col);
                    
                    JTable fsmvConfig = new JTable(model) {
                        
                        private static final long serialVersionUID = -5321345702024695381L;
                        public boolean isCellEditable(int rowIndex, int colIndex) {
                            return false; //Disallow the editing of any cell
                        }
                    };
                    
                    fsmvConfig.setAutoCreateRowSorter(true);
                    fsmvConfig.setAutoResizeMode(1);
                    fsmvConfig.setFont(new Font("Arial", Font.PLAIN, 14));
                    ListSelectionModel selectionModel = fsmvConfig.getSelectionModel();
                    selectionModel.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                    rowListener = new RowListener(fsmvConfig);
                    selectionModel.addListSelectionListener(rowListener);
                    fsmvConfig.setSelectionBackground(Color.BLUE);
                    fsmvConfig.setSelectionForeground(Color.WHITE);
                    fsmvConfig.setShowGrid(true);
                    JTableHeader header = fsmvConfig.getTableHeader();
                    header.setFont(new Font("Arial", Font.BOLD, 14));
                    header.setAutoscrolls(true);
                    JScrollPane pane2 = new JScrollPane(fsmvConfig);
                    mainTabbedPane.setFont(new Font("Arial", Font.PLAIN, 12));
                    String strTemp[] = fileSelected.getName().split("\\.");
                    pane2.setName(strTemp[0] + " Mapping");
                    mainTabbedPane.add(pane2.getName(), pane2);
                    mainTabbedPane.setSelectedComponent(pane2);
                    
                    fsmvConfig.getColumn(col[0]).setWidth(5);
                }
                else 
                {
                    JOptionPane.showMessageDialog(mainPanel, "No Records Found.");
                }
                
            }
            catch (IOException e)
            {
                JOptionPane.showMessageDialog(mainPanel, "Exception occured in calling service.", "Exception", JOptionPane.ERROR_MESSAGE);
                Logger.getLogger(FSMvGUIView.class.getName()).log(Level.SEVERE, null, e);
            }
        } else 
        {
            System.out.println("User pressed canceled.");
        }
    }
    
}
