package lucci.io.stream;

import java.io.*;

public class InputStreamStreamSource extends AbstractStreamSource
{
	private InputStream inputStream;
	private boolean isCompressed = false;

	public InputStreamStreamSource( InputStream inputStream )
	{
	    setInputStream( inputStream );
	}

	public boolean isReadable()
	{
		return true;
	}

	public boolean isWritable()
	{
		return false;
	}

	public String getName()
	{
		return null;
	}

	public boolean isCompressed()
	{
		return isCompressed;
	}

	public void setCompressed( boolean compressed )
	{
	    this.isCompressed = compressed;
	}

	public InputStream createInputStreamImpl()
		throws IOException
	{
		return inputStream;
	}

	public OutputStream createOutputStreamImpl()
		throws IOException
	{
		throw new IllegalStateException();
	}

	public void setAsText( StreamSource ref, String s )
	{
		throw new IllegalStateException( "operation has no meaning" );
	}

	/**
	 * @return the input stream.
	 */
	public InputStream getInputStream()
	{
		return inputStream;
	}


	/**
	 * Sets the input stream.
	 */
	public void setInputStream( InputStream inputStream )
	{
		if ( inputStream == null )
			throw new IllegalArgumentException( "inputStream cannot be set to null" );

		this.inputStream = inputStream;
	}

	public String getProtocol()
	{
		return null;
	}
}