package lucci.io.stream;

import java.io.*;

public class OutputStreamStreamSource extends AbstractStreamSource
{
	private OutputStream outputStream;
	private boolean isCompressed = false;

	public OutputStreamStreamSource( OutputStream outputStream )
	{
	    setOutputStream( outputStream );
	}

	public boolean isReadable()
	{
		return false;
	}

	public boolean isWritable()
	{
		return true;
	}

	public String getName()
	{
		return null;
	}

	public boolean isCompressed()
	{
		return isCompressed;
	}

	public void setCompressed( boolean compressed )
	{
	    this.isCompressed = compressed;
	}

	public InputStream createInputStreamImpl()
		throws IOException
	{
		throw new IllegalStateException();
	}

	public OutputStream createOutputStreamImpl()
		throws IOException
	{
		return outputStream;
	}

	public void setAsText( StreamSource ref, String s )
	{
		throw new IllegalStateException( "operation has no meaning" );
	}

	/**
	 * @return the output stream.
	 */
	public OutputStream getOutputStream()
	{
		return outputStream;
	}


	/**
	 * Sets the output stream.
	 */
	public void setOutputStream( OutputStream outputStream )
	{
		if ( outputStream == null )
			throw new IllegalArgumentException( "outputStream cannot be set to null" );

		this.outputStream = outputStream;
	}

	public String getProtocol()
	{
		return null;
	}
}