package lucci.io.stream;

import java.util.regex.PatternSyntaxException;

public class StreamSourceFactory
{
	private StreamSource createStreamSource( String streamSourceProtocol )
	{
		if ( streamSourceProtocol == null )
		{
			return new JavaResourceStreamSource();
		}
		else if ( streamSourceProtocol.equals( "resource" ) )
		{
			return new JavaResourceStreamSource();
		}
		else
		{
			return new URLStreamSource();
		}
	}

	public StreamSource createStreamSource( StreamSource refStreamSource, String StreamSourceName )
	{
		String StreamSourceProtocol = getStreamSourceProtocol( refStreamSource, StreamSourceName );
		StreamSource StreamSource = createStreamSource( StreamSourceProtocol );
		StreamSource.setAsText( refStreamSource, StreamSourceName );
		return StreamSource;
	}

	private String getStreamSourceProtocol( StreamSource refStreamSource, String streamSourceName )
	{
		try
		{
			if ( streamSourceName.matches("[a-zA-Z]+://.*") )
			{
				return streamSourceName.substring( 0, streamSourceName.indexOf( "://" ) );
			}
			else
			{
				if ( refStreamSource == null )
				{
					return "resource";
				}
				else
				{
					return refStreamSource.getProtocol();
				}
			}
		}
		catch ( PatternSyntaxException ex )
		{
			throw new IllegalStateException();
		}
	}
}
