package toools.beans;

import java.lang.reflect.Method;

import toools.math.Interval;


public class Beans
{
	public static Method getMethodThatHasNoArgument(Class<?> clazz, String methodName)
	{
		// System.out.println("- " + clazz + " searching for " + methodName);
		try
		{
			return clazz.getMethod(methodName, new Class[0]);
		}
		catch (Exception e)
		{
			return null;
			// if (clazz == Object.class)
			// {
			// return null;
			// }
			// else
			// {
			// return getMethodThatHasNoArgument(clazz.getSuperclass(),
			// methodName);
			// }
		}
	}

	public static Class<?> getPropertyType(Class<?> beanClass, String propertyName)
	{
		return getMethodThatHasNoArgument(beanClass, getGetterName(propertyName)).getReturnType();
	}

	public static String getGetterName(String propertyName)
	{
		return "get" + Character.toUpperCase(propertyName.charAt(0)) + propertyName.substring(1);
	}

	public static String getSetterName(String propertyName)
	{
		return "set" + Character.toUpperCase(propertyName.charAt(0)) + propertyName.substring(1);
	}

	public static void main(String[] args)
	{
		System.out.println(getPropertyType(Interval.class, "lowerBound"));
	}

}
