package toools.collections;

import toools.math.MathsUtilities;

public class MemoryEfficientIntOrderedList extends MemoryEfficientIntList
{
    @Override
    public void insertAt(int index, int value)
    {
        throw new UnsupportedOperationException("use insert(int) instead");
    }

    public void insert(int value)
    {
        super.insertAt(dichotomicIndexSearch(value), value);
    }

    @Override
    public void set(int index, int newValue)
    {
        throw new UnsupportedOperationException("use insert(int) instead");
//        if (index > 0)
//        {
//            Assertions.ensure(get(index - 1) <= newValue);
//        }
//
//        if (index < getSize() - 1)
//        {
//            Assertions.ensure(get(index + 1) >= newValue);
//        }
//
//        super.set(index, newValue);
    }

    private int dichotomicIndexSearch(int value)
    {
        int lb = 0, ub = getSize();

        while (true)
        {
            if (lb == ub)
            {
                return lb;
            }
            else if (lb + 1 == ub)
            {
                return value < get(lb) ? lb : ub;
            }
            else
            {
                int m = (lb + ub) / 2;

                if (value <= get(m))
                {
                    ub = m;
                }
                else
                {
                    lb = m;
                }
            }
        }
    }

    @Override
    public int indexOf(int value)
    {
        int index = dichotomicIndexSearch(value);
        return get(index) == value ? index : -1;
    }

    public static void main(String... args)
    {
        System.out.println("starting");
        MemoryEfficientIntOrderedList l = new MemoryEfficientIntOrderedList();

        for (int i = 0; i < 100; ++i)
        {
            l.insert((int) MathsUtilities.pickRandomBetween(0, 100, null));
        }

        System.out.println(l);
        System.out.println(l.indexOf(4));
    }
}
