package toools.collections;
import java.util.ArrayList;
import java.util.Iterator;

public class NullJumperArrayList<E> extends ArrayList<E>
{
    @Override
    public Iterator<E> iterator()
    {
        return new It();
    }

    private static final long serialVersionUID = 7665833479209653589L;

    private class It implements Iterator
    {
        int i = -1;

        E next = null;

        @Override
        public boolean hasNext()
        {
            while (++i < size())
            {
                next = get(i);

                if (next != null)
                {
                    return true;
                }
            }

            return false;
        }

        @Override
        public E next()
        {
            return next;
        }

        @Override
        public void remove()
        {
            throw new IllegalStateException();
        }

    }

}
