package toools.collections;

import java.util.AbstractCollection;
import java.util.Collection;
import java.util.Iterator;

public class Union<E> extends AbstractCollection<E>
{
	private final  Collection<E>[] sets;
	
	public Union(Collection<E>... c)
	{
		this.sets = c;
	}
	
	
	@Override
	public Iterator<E> iterator()
	{
		return new Iterator<E>() {
			int i = 0;
			Iterator<E> subi;
			
			@Override
			public boolean hasNext()
			{
				return subi.hasNext();
			}

			@Override
			public E next()
			{
				E e = subi.next();
				
				if (!subi.hasNext())
				{
					subi = sets[++i].iterator();
				}

				return e;
			}

			@Override
			public void remove()
			{
				subi.remove();
			}
			
		};
	}

	@Override
	public int size()
	{
		int sz = 0;
		
		for (Collection<E> c : this.sets)
		{
			sz += c.size();
		}

		return sz;
	}

}
