package toools.gui;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.nio.ByteBuffer;

import javax.swing.JFrame;

import toools.io.file.RegularFile;


import com.sun.pdfview.PDFFile;
import com.sun.pdfview.PDFPage;
import com.sun.pdfview.PagePanel;

public class FIGRenderingAWTComponent extends PagePanel
{
	public void setPDFData(byte[] bytes, int pageNumber)
	{
		ByteBuffer buf = ByteBuffer.wrap(bytes);
		
		try
		{
			PDFFile pdffile = new PDFFile(buf);
			System.out.println(pdffile.getNumPages());
			PDFPage page = pdffile.getPage(pageNumber);
			showPage(page);
			doLayout();
			repaint();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

	}

	public void displayInJFrame(String title)
	{
		final JFrame f = new JFrame( title);
		f.setContentPane(this);
		f.setSize(600, 450);
		f.setVisible(true);
		f.doLayout();
		f.repaint();

		f.addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent e)
			{
				f.dispose();
			}
		});

	}
	
	public static void main(String[] args) throws IOException
	{
		FIGRenderingAWTComponent p = new FIGRenderingAWTComponent();
		p.displayInJFrame("test");
		p.setPDFData(new RegularFile("/Users/lhogie/Downloads/grph-user-manual.pdf").getContent(), 0);
	}
}
