package toools.gui;

import java.awt.Color;

import com.carrotsearch.hppc.IntObjectOpenHashMap;

/*
 * Created on May 11, 2005
 */

/**
 * @author luc.hogie
 */
public class TrueColors24Map implements ColorPalette
{
	private IntObjectOpenHashMap<Color> map = new IntObjectOpenHashMap();

	@Override
	public Color getColorAtIndex(int index)
	{
		if (index < 0)
			throw new IllegalArgumentException("color can't be negative");

		if (index >= 16777216)
			throw new IllegalArgumentException("color can't be greater than 16777216");

		Color c = map.get(index);

		if (c == null)
		{
			map.put(index, c = new Color(index));
		}

		return c;
	}

	@Override
	public int getNumberOfColors()
	{
		return 16777216;
	}
	
	public int getNumberOfColorsInUse()
	{
		return map.size();
	}

}
