package toools.img;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.WritableRaster;

public class Utilities
{
	public static BufferedImage toBufferedImage(Image image, ColorModel cm)
	{
		if (image instanceof BufferedImage && ((BufferedImage) image).getColorModel().equals(cm))
		{
			return (BufferedImage) image;
		}
		else
		{
			int w = image.getWidth(null);
			int h = image.getHeight(null);
			boolean alphaPremultiplied = cm.isAlphaPremultiplied();
			WritableRaster raster = cm.createCompatibleWritableRaster(w, h);
			BufferedImage result = new BufferedImage(cm, raster, alphaPremultiplied, null);
			Graphics2D g = result.createGraphics();
			g.drawImage(image, 0, 0, null);
			g.dispose();
			return result;
		}
	}
}
