package toools.io;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

public class TeeOutputStream extends OutputStream
{
	private final List<OutputStream> streams = new ArrayList<OutputStream>();

	public List<OutputStream> getOutputStreams()
	{
		return this.streams;
	}

	@Override
	public void write(int b) throws IOException
	{
		for (OutputStream thisOutputStream : this.streams)
		{
			thisOutputStream.write(b);
		}
	}

	@Override
	public void flush() throws IOException
	{
		for (OutputStream thisOutputStream : this.streams)
		{
			thisOutputStream.flush();
		}
	}

}
