package toools.io.file;



public abstract class FileFilter
{
	public abstract boolean accept(AbstractFile f);
	

	    public static class RegularFileFilter extends FileFilter
	    {
		@Override
		public boolean accept(AbstractFile f)
		{
		    return f instanceof RegularFile;
		}

	    }
	    
	    public static class DirectoryFilter extends FileFilter
	    {
		@Override
		public boolean accept(AbstractFile f)
		{
		    return f instanceof Directory;
		}
	    }

	    public static class RegexFilter extends FileFilter
	    {
		private String re;

		public RegexFilter(String re)
		{
		    this.re = re;
		}

		@Override
		public boolean accept(AbstractFile f)
		{
		    return f.getName().matches(re);
		}
	    }
}
