package toools.log;

import java.text.SimpleDateFormat;
import java.util.Calendar;

public abstract class Logger
{
    public static Logger standardOutputLogger = new StdOutLogger();
    
    
    public abstract void log(Object o);

    public void logWithDate(Object o)
    {
	log(now() + " --- " + o);
    }

    private static final String DATE_FORMAT_NOW = "yyyy-MM-dd HH:mm:ss";

    private static String now()
    {
	Calendar cal = Calendar.getInstance();
	SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
	return sdf.format(cal.getTime());

    }

}
