package toools.math;


/**
 * A non-ordered pair.
 * 
 * @author lhogie
 * 
 * @param <E>
 * @param <B>
 */

public class Couple<E>
{
    private E e1_;
    private E e2_;

    public Couple(E a, E b)
    {
    	if (a == null)
    		throw new NullPointerException();

    	if (b == null)
    		throw new NullPointerException();

    	e1_ = a;
    	e2_ = b;
    }

    @Override
    public int hashCode()
    {
        int ah = e1_.hashCode();
        int bh = e2_.hashCode();
        return (Math.min(ah, bh) + ":" + Math.max(ah, bh)).hashCode();
    }

    @Override
    public boolean equals(Object o)
    {
        return o.getClass() == Couple.class && o.hashCode() == hashCode();
    }

    public E getA()
    {
        return e1_;
    }

//    public void setA(E a)
//    {
//        if (a == null)
//            throw new IllegalArgumentException();
//
//        this.e1_ = a;
//    }

    public E getB()
    {
        return e2_;
    }

//    public void setB(E b)
//    {
//        if (b == null)
//            throw new IllegalArgumentException();
//
//        this.e2_ = b;
//    }
    
    public E getOtherElement(E e)
    {
        if (e == this.e1_)
        {
            return e2_;
        }
        else if (e == this.e2_)
        {
            return e1_;
        }
        else
        {
            throw new IllegalStateException("no such element");
        }
    }
}
