package toools.math;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;


public class HashMatrix<X, Y, V> extends Matrix<X, Y, V>
{
	private Map<X, Map<Y, V>> map = new HashMap<X, Map<Y, V>>();

	@Override
	public Collection<X> getXs()
	{
		return map.keySet();
	}

	@Override
	public Collection<Y> getYs()
	{
		Collection<Y> ys = new HashSet<Y>();

		for (X x : getXs())
		{
			ys.addAll(map.get(x).keySet());
		}

		return ys;
	}

	@Override
	public void set(X x, Y y, V value)
	{
		Map<Y, V> column = map.get(x);

		if (column == null)
		{
			column = new HashMap<Y, V>();
			map.put(x, column);
		}

		column.put(y, value);
	}

	@Override
	public V get(X a, Y b)
	{
		Map<Y, V> m = map.get(a);
		return m == null ? null : m.get(b);
	}

}
