package toools.math;


public class Interval
{
    private double lowerBound, upperBound;
    private boolean strict;
    
    public boolean isStrict()
	{
		return strict;
	}

	public void setStrict(boolean strict)
	{
		this.strict = strict;
	}

	public Interval(double lowerBound, double upperBound, boolean strict)
    {
        setBounds(lowerBound, upperBound);
    }
    
    public void setBounds(double lowerBound, double upperBound)
    {
        if (lowerBound > upperBound)
            throw new IllegalArgumentException("bounds are not acceptable");
        
        this.lowerBound = lowerBound;
        this.upperBound = upperBound;
    }

    public double getLowerBound()
    {
        return lowerBound;
    }

    public double getUpperBound()
    {
        return upperBound;
    }
    
    public double getWidth()
    {
        return getUpperBound() - getLowerBound();
    }

	public boolean include(double o)
	{
		if (isStrict())
		{
			return getLowerBound() < o && o < getUpperBound();
		}
		else
		{
			return getLowerBound() <= o && o <= getUpperBound();
		}
	}
}
