package toools.math;

import java.util.Collection;
import java.util.HashSet;


import toools.collections.AutoGrowingArrayList;


public class ListMatrix<X, Y, V> extends Matrix<X, Y, V>
{
	private AutoGrowingArrayList<AutoGrowingArrayList<V>> map = new AutoGrowingArrayList<AutoGrowingArrayList<V>>();
	Collection<X> xs = new HashSet<X>();
	Collection<Y> ys = new HashSet<Y>();

	@Override
	public Collection<X> getXs()
	{
		return xs;
	}

	@Override
	public Collection<Y> getYs()
	{
		return ys;
	}

	@Override
	public void set(X x, Y y, V value)
	{
		xs.add(x);
		ys.add(y);
		map.ensureIndexCanBeStored(x.hashCode());
		AutoGrowingArrayList<V> l = map.get(x.hashCode());
		
		if (l == null)
		{
			map.set(x.hashCode(), l = new AutoGrowingArrayList<V>());
		}
		
		l.set(y.hashCode(), value);
	}

	@Override
	public V get(X a, Y b)
	{
		int x = a.hashCode();
		
		if (x < map.size())
		{
			AutoGrowingArrayList<V> l = map.get(x);
			
			if (l == null)
			{
				return null;
			}
			else
			{
				int y = b.hashCode();

				if (y < l.size())
				{
					return l.get(y);
				}
				else
				{
					return null;
				}
			}
		}
		else
		{
			return null;
		}
	}
	
	public static void main(String[] args)
	{
		Matrix<Long, Integer, Double> m = new HashMatrix<Long, Integer, Double>();
		m.set(2L, 4, 5.3);
		m.set(2L, 1, 6.2);
		m.set(5L, 2, 9.5);
		m.set(1L, 5, 0.3);
		System.out.println(m);
	}

}
