package toools.math;

import java.util.Random;

import toools.math.MathsUtilities;



public class Position
{
    private double x, y;

    public double getX()
    {
        return x;
    }

    public double getY()
    {
        return y;
    }

    public void setXY(double newX, double newY)
    {
        x = newX;
        y = newY;
    }

    @Override
	public String toString()
    {
        return '(' + x + ", " + y + ')';
    }

    @Override
	public boolean equals(Object obj)
	{
		return obj instanceof Position && super.equals((Position) obj);
	}

	public boolean equals(Position l)
    {
        return x == l.x && y == l.y;
    }

    public double getDistanceTo(Position l)
    {
        double dx = x - l.getX();
        double dy = y - l.getY();
        double d = dx * dx + dy * dy;
        return Math.sqrt(d);
    }
 
    @Override
	public int hashCode()
    {
        return (x + ":" + y).hashCode();
    }

    
    public static Position createRandomLocation(double minX, double maxX, double minY, double maxY, Random pnrg)
    {
        Position l = new Position();
        l.setXY(MathsUtilities.pickRandomBetween(minX, maxX, pnrg), MathsUtilities.pickRandomBetween(minY, maxY, pnrg));
        return l;
    }
    
}
