package toools.math.relation;

import java.util.Collection;
import java.util.Iterator;

/*
 * Created on Aug 18, 2004
 */

/**
 * @author luc.hogie
 */
public class RelationUtilities
{
	
	public static <A, B> Relation<A, B> merge(Collection<Relation<A, B>> relations)
	{
		if (relations.isEmpty())
			throw new IllegalArgumentException("no functions to compute");
		
        Relation<A, B> mergeRelation = new HashRelation<A, B>();
        
		for (Relation<A, B> relation : relations)
		{
			for (A key : relation.getKeys())
            {
				mergeRelation.addAll(key, relation.getValues(key));
			}
		}
		
		return mergeRelation;
	}
    
    public static <A, B> boolean haveSameKeys(Collection<Relation<A, B>> relations)
    {
        if (relations.isEmpty())
            throw new IllegalArgumentException("no relation to compute");

        Iterator<Relation<A, B> > i = relations.iterator();
        Collection<A> refKeys = i.next().getKeys();
        
        while (i.hasNext())
        {
            if (!i.next().getKeys().equals(refKeys))
            {
                return false;
            }
        }
        
        return true;
    }
}
