package toools.text;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Vector;

public class Sort
{
    public static List<List> extractNumbers(List<List<String>> lines)
    {
        List<List> newLines = new Vector<List>();

        for (List<String> line : lines)
        {
            List newLine = new Vector();

            for (String token : line)
            {
                if (token.matches("[+-][0-9]+\\.[0-9]+"))
                {
                    newLine.add(Double.valueOf(token));
                }
                else
                {
                    newLine.add(token);
                }
            }

            newLines.add(newLine);
        }

        return newLines;

    }

    public static void sort(List<String> l)
    {
        Collections.sort(l, new Comparator<String>()
        {

            public int compare(String o1, String o2)
            {
                return o1.compareTo(o2);
            }
        });
    }

    public static void sort(List<List<String>> l, final int n, final boolean numericOrdering)
    {
        Collections.sort(l, new Comparator<List<String>>()
        {

            public int compare(List<String> o1, List<String> o2)
            {
                if (numericOrdering)
                {
                    return Double.valueOf(o1.get(n)).compareTo(Double.valueOf(o2.get(n)));
                }
                else
                {
                    return o1.get(n).compareTo(o2.get(n));
                }
            }
        });
    }
}
