package toools.thread;

import java.util.Collection;
import java.util.List;

public abstract class OneElementOneThreadProcessing extends CollectionMultiThreadProcessing
{
    public OneElementOneThreadProcessing(Collection<?> input)
    {
	super(input, input.size());
    }

    @Override
    protected final Object run(List<Thread> threads, int threadIndex, int lowerBound, int upperBound)
    {
	if (lowerBound >= upperBound)
	    throw new IllegalArgumentException();

	return run(threads, threadIndex, lowerBound);
    }

    protected abstract Object run(List<Thread> threads, int threadIndex, int elementIndex);
}
